#!/usr/bin/perl
use strict;
use warnings;
use DBI;

my $user = undef;
my $pass = undef;
my $host = undef;
my $filename = '/usr/local/opmon/etc/db.php';
# <?php
#        $DBUSER="root";
#        $DBPASS="oppass";
#        $DBHOST="127.0.0.1";
# ?>
if(open(FH, '<', $filename))
{
    while(<FH>)
    {
	if ($_ =~ s/DBUSER="(.*)";//) {
	    $user = $1;
	}
	if ($_ =~ s/DBPASS="(.*)";//) {
	    $pass = $1;
	}
	if ($_ =~ s/DBHOST="(.*)";//) {
	    $host = $1;
	}
    }

    close(FH);
} else {
    print "Couldn't Open a file $filename\n";
    exit(2);
}

if (! $user or ! $host) {
    print "Error parsing a file $filename\n";
    exit(2);
}

my $dbh = DBI->connect("DBI:mysql:opcfg:".$host,$user,$pass);

die "failed to connect to MySQL database:DBI->errstr()" unless($dbh);

# prepare SQL statement
my $sth = $dbh->prepare("CREATE TABLE temp_table_name (\n".
"	entry_time datetime,\n".
"	host_id INT,\n".
"	service_id INT,\n".
"	current_state INT,\n".
"	plugin_output text,\n".
"	host_name VARCHAR ( 128 ),\n".
"	state_type INT ( 10 ),\n".
"	KEY ( entry_time, service_id ) \n".
")")
or die "prepare statement failed: $dbh->errstr()";

$sth->execute() or warn "execution failed: $dbh->errstr()";

# prepare SQL statement
my $ret = $dbh->prepare("SELECT\n".
"	table_name \n".
"FROM\n".
"	`INFORMATION_SCHEMA`.`TABLES` \n".
"WHERE\n".
"	TABLE_NAME LIKE \"%\\_state_change\\_%\"")
or die "prepare statement failed: $dbh->errstr()";

$ret->execute() or warn "execution failed: $dbh->errstr()";

# prepare SQL statement
my $hosts = $dbh->prepare("SELECT\n".
"	host_id \n".
" host_name \n".
"FROM\n".
"	`opcfg`.`nagios_hosts`")
or die "prepare statement failed: $dbh->errstr()";

$hosts->execute() or warn "execution failed: $dbh->errstr()";

my @hosts_in_opcfg;
while (my (@host_id,@host_name) = $hosts->fetchrow_array()) {
      push(@hosts_in_opcfg, $host_id[0]);
}
 #print "@hosts_in_opcfg";

my @tables_in_opmon4;
while ((my @table_name) = $ret->fetchrow_array()) {
      push (@tables_in_opmon4, $table_name[0]);
}
#print "@tables_in_opmon4\n";

foreach my $host_id(@hosts_in_opcfg) {
    #if (exists(my %tables_in_opmon4{"host_state_change_1"})) {
    #if (@tables_in_opmon4->contains('host_state_change_1')){
    if (grep {$ _ eq "host_state_change_${host_id}"} @tables_in_opmon4) {
    #  print $host_id;
    my $sql = $dbh->prepare("insert into opcfg.temp_table_name (entry_time,host_id,service_id,current_state,plugin_output,host_name,state_type) " .
                        "select entry_time, " .
                        "       ${host_id} as host_id, " .
#                        "         1 as host_id,  " .
                        "       0 as service_id, " .
                        "       current_state+10 as current_state, " .
                        "       plugin_output, " .
#                        "       ${host_name}  as host_name, " .
                        "       'teste' as host_name, " .
                        "       state_type " .
                        "from opmon4.host_state_change_${host_id} ")
    or die "prepare statement failed: $dbh->errstr()";

    $sql->execute() or die "execution failed: $dbh->errstr()";
    }
}



$sth->finish();
$ret->finish();
$hosts->finish();
#$sql->finish();
$dbh->disconnect();
