#!/usr/bin/perl
use strict;
use warnings;
use DBI;
use FindBin;

my $dir = $FindBin::Bin;

my $user = undef;
my $pass = undef;
my $host = undef;
my $filename = '/usr/local/opmon/etc/db.php';
# <?php
#        $DBUSER="root";
#        $DBPASS="oppass";
#        $DBHOST="127.0.0.1";
# ?>
if(open(FH, '<', $filename))
{
    while(<FH>)
    {
	if ($_ =~ s/DBUSER="(.*)";//) {
	    $user = $1;
	}
	if ($_ =~ s/DBPASS="(.*)";//) {
	    $pass = $1;
	}
	if ($_ =~ s/DBHOST="(.*)";//) {
	    $host = $1;
	}
    }

    close(FH);
} else {
    print "Couldn't Open a file $filename\n";
    exit(2);
}

if (! $user or ! $host) {
    print "Error parsing a file $filename\n";
    exit(2);
}

my $dbh = DBI->connect("DBI:mysql:opcfg:".$host,$user,$pass);

die "failed to connect to MySQL database:DBI->errstr()" unless($dbh);

# prepare SQL statement
my $sth = $dbh->prepare("SELECT\n".
"	B.host_name,\n".
"	service_description,\n".
"	A.created,\n".
"	now() AS now,\n".
"	(\n".
"	DATEDIFF( now(), A.created )) AS diff \n".
"FROM\n".
"	nagios_services A\n".
"	INNER JOIN nagios_hosts B ON A.host_id = B.host_id \n".
"WHERE\n".
"	DATEDIFF( now(), A.created ) < '30' ORDER BY diff")
        or die "prepare statement failed: $dbh->errstr()";

$sth->execute() or warn "execution failed: $dbh->errstr()";

my $result = $sth->rows();
print $sth->rows();

my($host_name,$service_description,$created,$now,$diff) = $sth->fetchrow();


if ($result > '0') {
  print("$host_name, $service_description, $created\t\n");
} else {
  print ("Nenhum servico foi criado nos ultimos 30 dias \t\n");
}

# Salva conteudo hostname em arquivo TXT para consulta

my $txt1 = "";
if ($diff) {
$txt1 = <<END;
$diff
END
}

print $dir."\n";
my $filetxt = $dir.'/../files/resultado3.txt';

open(FH, '>', $filetxt) or die $!;
print FH $txt1;

close(FH);

######################################################

$sth->finish();
$dbh->disconnect();
