#!/usr/bin/perl
use strict;
use warnings;
use DBI;
use FindBin;

my $dir = $FindBin::Bin;

my $user = undef;
my $pass = undef;
my $host = undef;
my $filename = '/usr/local/opmon/etc/db.php';
# <?php
#        $DBUSER="root";
#        $DBPASS="oppass";
#        $DBHOST="127.0.0.1";
# ?>
if(open(FH, '<', $filename))
{
    while(<FH>)
    {
	if ($_ =~ s/DBUSER="(.*)";//) {
	    $user = $1;
	}
	if ($_ =~ s/DBPASS="(.*)";//) {
	    $pass = $1;
	}
	if ($_ =~ s/DBHOST="(.*)";//) {
	    $host = $1;
	}
    }

    close(FH);
} else {
    print "Couldn't Open a file $filename\n";
    exit(2);
}

if (! $user or ! $host) {
    print "Error parsing a file $filename\n";
    exit(2);
}

my $dbh = DBI->connect("DBI:mysql:opcfg:".$host,$user,$pass);
die "failed to connect to MySQL database:DBI->errstr()" unless($dbh);

# prepare SQL statement
my $sth = $dbh->prepare("SELECT\n".
"       host_name,\n".
"       created,\n".
"       now() AS now,\n".
"       (\n".
"       DATEDIFF( now(), created )) AS diff\n".
"FROM\n".
"       nagios_hosts\n".
"WHERE\n".
"       DATEDIFF( now(), created ) < '60' order by diff limit 1;")
        or die "prepare statement failed: $dbh->errstr()";

$sth->execute() or warn "execution failed: $dbh->errstr()";
my $result = $sth->rows();
my($host_name,$created,$now,$diff) = $sth->fetchrow();


if ($result > '0') {
  print("$host_name, $created\t\n");
} else {
  print ("Nao foi criado nenhum host nos ultimos 60 dias \t\n");
}

# Salva conteudo hostname em arquivo TXT para consulta
#}
my $txt1 = "";
if ($diff) {
$txt1 = <<END;
$diff
END
}

my $filetxt = $dir.'/../files/resultado2.txt';

open(FH, '>', $filetxt) or die $!;
print FH $txt1;


close(FH);

######################################################


$sth->finish();
$dbh->disconnect();
