#!/usr/bin/perl
use strict;
use warnings;
use DBI;

my $user = undef;
my $pass = undef;
my $host = undef;
my $filename = '/usr/local/opmon/etc/db.php';
# <?php
#        $DBUSER="root";
#        $DBPASS="oppass";
#        $DBHOST="127.0.0.1";
# ?>
if(open(FH, '<', $filename))
{
    while(<FH>)
    {
	if ($_ =~ s/DBUSER="(.*)";//) {
	    $user = $1;
	}
	if ($_ =~ s/DBPASS="(.*)";//) {
	    $pass = $1;
	}
	if ($_ =~ s/DBHOST="(.*)";//) {
	    $host = $1;
	}
    }

    close(FH);
} else {
    print "Couldn't Open a file $filename\n";
    exit(2);
}

if (! $user or ! $host) {
    print "Error parsing a file $filename\n";
    exit(2);
}

my $dbh = DBI->connect("DBI:mysql:opcfg:".$host,$user,$pass);

die "failed to connect to MySQL database:DBI->errstr()" unless($dbh);

# prepare SQL statement
my $sth = $dbh->prepare("SELECT\n".
"	host_name,\n".
"	service_description,\n".
"	last_state_change,\n".
"	now() AS now,\n".
"	DATEDIFF( now(), last_state_change ) AS diff \n".
"FROM\n".
"	service_status \n".
"WHERE\n".
"	DATEDIFF( now(), last_state_change ) > 30 \n".
"	AND state_type = 1 \n".
"	AND last_state = 2 \n".
"	AND problem_has_been_acknowledged > 0")
        or die "prepare statement failed: $dbh->errstr()";

$sth->execute() or warn "execution failed: $dbh->errstr()";

my $result = $sth->rows();

if ($result > '0') {
  while (my($host_name,$service_description,$last_state_change,$now,$diff) = $sth->fetchrow()) {
      print "$host_name,$service_description,$diff\n";
   }
} else {
  print ("Nao foi encontrado nenhum servico sem ack \t\n");
}

$sth->finish();
$dbh->disconnect();
