#!/usr/bin/perl
use strict;
use warnings;
use DBI;
use FindBin;

my $dir = $FindBin::Bin;

my $user = undef;
my $pass = undef;
my $host = undef;
my $filename = '/usr/local/opmon/etc/db.php';
# <?php
#        $DBUSER="root";
#        $DBPASS="oppass";
#        $DBHOST="127.0.0.1";
# ?>
if(open(FH, '<', $filename))
{
    while(<FH>)
    {
	if ($_ =~ s/DBUSER="(.*)";//) {
	    $user = $1;
	}
	if ($_ =~ s/DBPASS="(.*)";//) {
	    $pass = $1;
	}
	if ($_ =~ s/DBHOST="(.*)";//) {
	    $host = $1;
	}
    }

    close(FH);
} else {
    print "Couldn't Open a file $filename\n";
    exit(2);
}

if (! $user or ! $host) {
    print "Error parsing a file $filename\n";
    exit(2);
}

my $dbh = DBI->connect("DBI:mysql:opcfg:".$host,$user,$pass);

die "failed to connect to MySQL database:DBI->errstr()" unless($dbh);

# prepare SQL statement
my $sth = $dbh->prepare("SELECT\n".
"	host_id,\n".
"	service_id \n".
"FROM\n".
"	opcfg.nagios_services \n".
"WHERE\n".
"	service_description = 'OpMon_Latencia' \n".
"	AND host_id IS NOT NULL")
        or die "prepare statement failed: $dbh->errstr()";

$sth->execute() or warn "execution failed: $dbh->errstr()";

my $result = $sth->rows();
my($host_id,$service_id) = $sth->fetchrow();

#if ($result > '0') {
#     print "$host_id,$service_id\n";
#} else {
#  print ("O servico OpMon_Latencia nao foi encontrado\t\n");
#}

# prepare SQL statement
my $latency = $dbh->prepare("SELECT\n".
"	service_id,\n".
"	entry_time,\n".
"	now() AS now \n".
"FROM\n".
"	opmon4.service_state_change_${host_id}\n".
"WHERE\n".
"	service_id = ${service_id}\n".
"	AND current_state > 0 \n".
"	AND entry_time BETWEEN DATE_SUB( NOW(), INTERVAL 1 MONTH ) \n".
"	AND NOW();") or die "prepare statement failed: $dbh->errstr()";

$latency->execute() or warn "execution failed: $dbh->errstr()";

my $result_latency = $latency->rows();
#my($service,$entry_time) = $latency->fetchrow();

if ($result_latency > '5') {
  print("Foram detectados muitos alertas referentes ao OpMon_Latencia\t\n");
} else {
  print ("Nao foram detectados alertas referentes ao OpMon_Latencia \t\n");
}

#if ($result_latency > '10') {
#  print("$service, $entry_time\t\n");
#} else {
#  print ("O servico OpMon_Latencia nao foi encontrado \t\n");
#}

######################################################

#Salva conteudo numerico em arquivo TXT para consulta

my $txt1 = <<END;
$result_latency
END

my $filetxt = $dir.'/../files/latency-result.txt';

open(FH, '>', $filetxt) or die $!;
print FH $txt1;

close(FH);

######################################################

$sth->finish();
$latency->finish();
$dbh->disconnect();
