#!/usr/bin/php
<?php
include("/usr/local/opmon/etc/config.php");
set_logged_user('opmonadmin');

$tables_to_convert = array(
    'opcfg.user_session',
    'opmon4.dashboards',
    'opmon4.dashboards_resources',
    'opmon4.shared_resources',
    'opmon4.networkmaps'
);

print "Migrating tables to InnoDB\n";

foreach($tables_to_convert as $table_name) {
	list($db, $table) = preg_split('/\./', $table_name);
	$engine = check_table_engine($table, $db);
	if ($engine === false or $engine == "InnoDB" ) {
		print "Table $table_name already in $engine\n";
		continue;
	}
	else {
		$sql = "ALTER TABLE $db.$table ENGINE = InnoDB;";
	}
	$timeelapsed = time();
	print "Covnerting $sql ...";
	$ret = do_query($sql, $db);
	$ret->Close();
	$timeelapsed = time() - $timeelapsed;
	print $timeelapsed."s done\n";
}
print "Migration Done\n";
exit(0);

/* returns the size of the table in MB */
function check_table_engine($table_name, $dbname)
{
        $ret = false;
        $tables_exists=check_table_exists($table_name, $dbname);
        if ($tables_exists===FALSE)
                return $ret;

        $query="SELECT ENGINE as engine FROM information_schema.TABLES  WHERE table_schema = '$dbname' and table_name = '$table_name';";
        $result = do_query($query,$dbname,OPDB_FETCH_OBJ);
        if ($result->RecordCount() > 0) {
                $obj=$result->fields;
                $ret = $obj->engine;
        }
        return($ret);
}

function check_table_exists($table_name, $dbname)
{
        $query="show tables;";
        $result = do_query($query,$dbname);

        $tables = array();
        while( !$result->EOF ) {
                $tables[]=array_shift($result->fields);
                $result->MoveNext();
        }
        $result->Close();
        $found=array_search($table_name, $tables);
        return($found);
}

?>
