#!/usr/bin/php -q
<?php
include "/usr/local/opmon/etc/config.php";
define("USER","externaluser");
global $mod;
$mod = 'OPVIEW';

if (count($argv) < 3) {
	print "Check contact's permissions based on element\n";
	print "Usage: {$argv[0]} contact type [element_id]\n";
	print "Commands:\n contact - system contact name. ex: opmonadmin\n types - element type. ex: host|service|servicegroup|hostgroup\n element_id - optional element id to filter, otherwise will show all elements. ex: 1_34,1\n";
	print "\n Example 1: # $argv[0] operator servicegroup -- will check permissions for all servicesgroups using contact name operator.\n";
	print " Example 2: # $argv[0] operator service 1_2 -- will check permissions for service id 1_2 (host_id_service_id) using contact name operator.\n\n";

	exit;
}


$contact = (isset($argv[1])) ? get_contact_by_name($argv[1]) : false;
if (!$contact) {
	die("Error: Invalid contact name\n");
}
if (!isset($argv[2])) {
	die("Error: Invalid element type\n");
} else {
	$type = $argv[2];
}

$element_id = isset($argv[3]) ? $argv[3] : false;

set_logged_user("opmonadmin");

$elements = array();

switch ($type) {
	case 'host':
		$elements = get_hosts();
		break;
	case 'service':
		$elements = get_services();
		break;
	case 'servicegroup':
		$elements = get_servicegroups();
		break;
	case 'hostgroup':
		$elements = get_hostgroups();
		break;
	default:
		die("Error: Invalid element type\n");
		break;
}

$contact_name = $contact->get_contact_name();
$contact_id = $contact->get_contact_id();
set_logged_user($contact_name);
$service_permission = get_services_matrix();
print "Contact: $contact_name($contact_id)\n";

$groups_perms = array();

foreach ($elements as $e) {
	if (isset($e->hostgroup_id)) {
		$id = $e->hostgroup_id;
		$name = "{$e->host_name} ({$e->host_id})";
		$groupby = "Hostgroup: {$e->hostgroup_name} ({$e->hostgroup_id})";
		$perm = isset($service_permission[$e->host_id]);
	} else if (isset($e->servicegroup_id)) {
		$id = $e->servicegroup_id;
		$name = "{$e->host_name} - {$e->service_description} ({$e->host_id}!{$e->service_id})";
		$groupby = "Servicegroup: {$e->servicegroup_name} ({$e->servicegroup_id})";
		$perm = isset($service_permission[$e->host_id][$e->service_id]);
	} else if (isset($e->service_id)) {
		$id = "{$e->host_id}_{$e->service_id}";
		$name = "{$e->service_description} ({$id})";
		$groupby = "Host - {$e->host_name} ({$e->host_id})";
		$perm = isset($service_permission[$e->host_id][$e->service_id]);
	} else if (isset($e->host_id)) {
		$id = $e->host_id;
		$name = "{$e->host_name} ({$id})";
		$groupby = "Host";
		$perm = isset($service_permission[$e->host_id]);
	}
	if (($element_id && $element_id == $id) || !$element_id) {
		$e->has_permission = $perm;
		$e->name = $name;
		$groups_perms[$groupby][] = $e;
	}

}


foreach ($groups_perms as $group_name => $members) {
	print $group_name ." - Total: ".count($members)."\n";
	foreach ($members as $member) {
		print "- \033[37m{$member->name}\033[37m - ". (($member->has_permission) ? "\033[32mPermission Ok\033[37m" : "\033[31mNo Permission\033[37m") ."\n";
	}
	print "\n";
}
?>