#!/usr/bin/perl
use strict;

our $statusfile = "/usr/local/opmon/var/status.log";
our $logfile = "/usr/local/opmon/var/restart-opmon.log";
our $maxtime = 600; # seconds

sub main {
	my @stat = stat($statusfile);
	my $now = time();
	restart_opmon() if ( ($now - $stat[9]) > $maxtime );
	logger("Processo opmon rodando normalmente...");
}

sub restart_opmon {
	logger("Parando processo OpMon");
	my $ret = `/sbin/service opmon stop`;
	logger($ret);
	logger("Iniciando processo OpMon");
	$ret = `/sbin/service opmon start`;
	logger($ret);
}

sub logger {
	my $msg = shift;
	open(LOG,">>$logfile");
	my $date = `date`;
	chomp $date;
	print LOG "[$date]:\n";
	print LOG "$msg\n";
	close(LOG);
}

main;
