#!/usr/bin/perl

($hostname, $ifname)=@ARGV;

use DBI;
use POSIX;

$VERSION="1.1";

$DBSERVER="localhost";
$DBNAME="stats";
$DBUSER="root";
$DBPASS="oppass";

print "Starting clean_nisca_db.pl Version $VERSION\n\n";
$start=time();

$dbh = DBI->connect ( "dbi:mysql:dbname=$DBNAME;host=$DBSERVER", "$DBUSER", "$DBPASS");
if ( !defined $dbh ) {
        die "Cannot connect to database!\n";
}

$sql="SELECT count(*) FROM interfaces";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
($count_interfeces_begin) = $sth->fetchrow();
$sth->finish();

$sql="SELECT count(*) FROM stats_ifs";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
($count_stats_ifs_begin) = $sth->fetchrow();
$sth->finish();

$sql="SELECT count(*) FROM stats";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
($count_stats_begin) = $sth->fetchrow();
$sth->finish();

print "interfaces: $count_interfeces_begin\n";
print "stats_ifs:  $count_stats_ifs_begin\n";
print "stats: $count_stats_begin\n";

print "Cleaning stats_ifs\n";
$#HOSTNANAME=-1;
$#IFNAME=-1;
$sql="select hostname,if_name from stats_ifs order by hostname, if_name";
$sth2=$dbh->prepare($sql);
if ( !defined $sth2 ) {
  die "Cannot prepare statement: $DBI::errstr\n";
}
$sth2->execute();
while( ($hostname,$if_name)=$sth2->fetchrow() ) {
   #print "$hostname $if_name\n";
   $sql="select count(*) from interfaces where hostname='$hostname' and if_name='$if_name'";

   $sth=$dbh->prepare($sql);
   if ( !defined $sth ) {
     die "Cannot prepare statement: $DBI::errstr\n";
   }
   $sth->execute;
   $count=-1;
   ($count) = $sth->fetchrow();
   $sth->finish();
   if ($count==0) {
      push @HOSTNAME, $hostname;
      push @IFNAME, $if_name;
   }
   #print "$hostname $if_name $count\n";
}
$sth2->finish();

for ($i=0;$i<=$#HOSTNAME;$i++) {
   print "$HOSTNAME[$i]    $IFNAME[$i]\n";
   #print "$hostname $if_name\n";
   $sql="delete from stats_ifs where hostname='$HOSTNAME[$i]' and if_name='$IFNAME[$i]'";
   print "$sql...";
   $sth2=$dbh->prepare($sql);
   if ( !defined $sth2 ) {
     die "Cannot prepare statement: $DBI::errstr\n";
   }
   $sth2->execute;
   print "done\n";
   $sth2->finish();
}
print "Cleaning stats_ifs done\n\n";

print "Cleaning stats tables \n";
$sql="SELECT distinct if_id FROM stats";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$count_zero=0;
$count_not_zero=0;
$#IDS=-1;
while (($id) = $sth->fetchrow()) {
   $sql="select count(*) from stats_ifs where id=$id";
   $sth2=$dbh->prepare($sql);
   if ( !defined $sth2 ) {
     die "Cannot prepare statement: $DBI::errstr\n";
   } 
   $sth2->execute;
   ($count) = $sth2->fetchrow();
   $sth2->finish();
   
   if ($count==0) {
      #print "stats_ifs - $id - $count\n";
      $count_zero++;
      push(@IDS, $id);
   }
   else {
      $count_not_zero++;
   }
}
$sth->finish();
foreach $id (@IDS) {
   $sql="delete from stats where if_id=$id";
   print "$sql...";
   $sth2=$dbh->prepare($sql);
   if ( !defined $sth2 ) {
     die "Cannot prepare statement: $DBI::errstr\n";
   }
   $sth2->execute;
   print "done\n";
   $sth2->finish();
}
print "Cleaning stats tables done\n\n";

$sql="SELECT count(*) FROM interfaces";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
($count_interfeces_end) = $sth->fetchrow();
$sth->finish();

$sql="SELECT count(*) FROM stats_ifs";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
($count_stats_ifs_end) = $sth->fetchrow();
$sth->finish();

$sql="SELECT count(*) FROM stats";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
($count_stats_end) = $sth->fetchrow();
$sth->finish();

$t1=$count_interfeces_begin-$count_interfeces_end;
$t2=$count_stats_ifs_begin-$count_stats_ifs_end;
$t3=$count_stats_begin-$count_stats_end;

print "            \tBefore\t\tAfter\t\tRemoved\n";
print "interfaces: \t$count_interfeces_begin\t\t$count_interfeces_end\t\t$t1\n";
print "stats_ifs:  \t$count_stats_ifs_begin\t\t$count_stats_ifs_end\t\t$t2\n";
print "stats:      \t$count_stats_begin\t$count_stats_end\t$t3\n";

$dbh->disconnect();

$end=time();

$elapse_time=$end-$start;
if ($elapse_time>60) {
   $elapse_time=$elapse_time/60;
   print "Elapsed time $elapse_time minutes\n"; 
}
else {
   print "Elapsed time $elapse_time seconds\n"; 
}

exit(0);
