<?php

/**
 * THIS SCRIPT GENERATES CAPACITY PLANNING FOR
 * ALL OPMON SERVICES AND STORE THE FILES INSIDE 
 * A DIRECTORY 
 */


include "/usr/local/opmon/etc/config.php";

// repo destination directory
define("DESTINATION_DIR","/var/tmp/reports");

$periods_to_generate = array(
	"last24hours",
	"last7days",
	"last31days"
);

function main() {

	global $mod;
	global $periods_to_generate;

	$mod = "EXTERNAL";

	set_logged_user("opmonadmin");

	@mkdir(DESTINATION_DIR);

	$hosts = get_hosts();

	/**
	 * we are going to generate a separate pdf for
	 * every host
	 */
	$report_generator = new GenReport();
	foreach($hosts as $host) {

		$host_id = $host->host_id;
		$host_name = $host->host_name;

		$directory_host_reports = sprintf("%s/%s",DESTINATION_DIR,$host->host_name);
		@mkdir($directory_host_reports);

		$services = get_host_services( $host_id );
		foreach($services as $service) {

			if (!$service->has_cp()) {
				continue;
			}

			$host_service_id = sprintf("%s!%s",$host_id,$service->get_service_id());

			$report = new SavedReport();
			$report->add_propertie("selectedItens",$host_service_id);
			$report->add_propertie("formTo",CPREPORT);
			$report->add_propertie("reportType",CPDEFAULT);
			$report->add_propertie("mod","CP");
			$report->add_propertie("sendByEmail",false);
			$report->add_propertie("objectType",SERVICE);
			$report->add_propertie("timeCutId",100);
			$report->add_propertie("reportPeriod","last7days");
			$report->add_propertie("timeCutName","24x7");

			foreach($periods_to_generate as $period) {

				$directory_for_report = sprintf("%s/%s",$directory_host_reports,$period);

				@mkdir($directory_for_report);

				$report->reportPeriod = $period;
				$report->reportName = sprintf("%s_%s",str_replace("/", "_", $service->get_service_description()), $period);

				print sprintf("Generating PDF for %s %s (%s)...",$host_name,$service->get_service_description(), $period);

				$report_destination_full_path = sprintf("%s/%s.pdf",$directory_for_report, $report->reportName);
				if (file_exists($report_destination_full_path)) {
					print "already generated\n";
					continue;
				}

				$generated_pdf = $report_generator->gen_pdf_directly($report);
				if ($generated_pdf !== false) {
					print "success.\n";
					copy($generated_pdf, $report_destination_full_path);
				} else {
					print "fail.\n";
				}

			}

		}


	}

	print sprintf("All reports created on directory %s\n",DESTINATION_DIR);


}



main();

?>
