<?php

include "/usr/local/opmon/etc/config.php";

$obj = new StdClass();
$obj->host_id = 100;
$obj->service_id = 1001;

$config = array();
$config['type'] = 1; // Business
$config['responsable'] = 1; // opmonadmin
$config['next_revision'] = date('d/m/Y',strtotime("+1 month"));
$config['last_revision'] = date('d/m/Y',time());
$config['cost'] = 100;
$config['levels'] = array("1" => array($obj));
$config['selectedTimecut'] = 100; // 24x7


function print_usage() {
	print "Usage:";
	print "\tphp import-scats-xls.php -f <input file> [-h]\n";
	exit;
}

function main() {

	global $config;

	$opts = array();
	$opts = getopt("hf:");


	if (!isset($opts['f']) || isset($opts['h'])) {
		print_usage();
	}

	if (!file_exists($opts['f'])) {
		print "Unable to access file {$opts['f']}\n";
		print_usage();
	}

	$lines = array();
	$lines = file($opts['f']);

	$first = true;
	foreach($lines as $line) {

		if ($first) {
			$first = false;
			continue;
		}

		$cols = array();
		$cols = explode(";",$line);

		if (empty($cols[0]))
			continue;

		$scat = new Scat();
		$scat->name = $cols[0];
		$scat->description = $cols[1];
		$scat->resolutionTime = $cols[10];
		$scat->answerTime = $cols[11];
		$scat->selectedSeverity = getSevById($cols[4]);
		$scat->imageInjury = getSevById($cols[5]);
		$scat->complexity = getSevById($cols[6]);
		$scat->vipUsers = ($cols[7] == 'Sim' || $cols[7] == 'sim') ? 1 : 0;

		if (preg_match("/^At*+/",$cols[8])) {
			$scat->selectedAffectedUsers = 0; 
		} else if (preg_match("/^Acim*+/",$cols[8])) {
			$scat->selectedAffectedUsers = 100;
		} else {
			$scat->selectedAffectedUsers = 200;
		}

		$scat->dependencyRelationship = getSevById($cols[9]);
		$scat->involvedApplications = $cols[18];
		$scat->txtUser = $cols[2];

		foreach($config as $key => $value) {
			$scat->$key = $value;
		}

		$saz = array();
		for($i=19; $i<=49; $i++) {
			$idx = $i - 19;
			$saz[$idx] = ($cols[$i] == 'Sim' || $cols[$i] == 'sim') ? 1 : 0;
		}
		$scat->sazDays = $saz;

		$scat->store();
	}

}

function getSevById($sev) {
	if ($sev == 'Alto' || $sev == 'Alta') {
		return 2; 
	} else if ($sev == 'Baixo' || $sev == 'Baixa') {
		return 0;
	} else {
		return 1;
	}
}


main();
?>
