#!/usr/bin/php
<?

$logFile = "/var/log/opmon-license.log";

/* Agent must test both license and see which onde will be kept on disk */
/* License Old - license that was on disk and was copied when ioncube_loader was installed */
$licenseOld = "/usr/local/opmon/opmon-lic.txt-old";
$licenseTypeOld = 0;

/* License New - license beeing installed by ioncube_loader, probably OpMon free */
$licenseNew = "/usr/local/opmon/opmon-lic.txt-new";
$licenseTypeNew = 0;

if (!file_exists($licenseOld)) {
	writeLog("License file ".$licenseOld." not found ");
	exit(0);
}

/* Lincetype:
	- 0 : Premium, custom, other valid
	- 1 : Free
	- 2 : Not valid
*/
$licenseTypeOld = checkLicenseType($licenseOld);
writeLog("License old of type ". getLicenseType($licenseTypeOld));
$licenseTypeNew = checkLicenseType($licenseNew);
writeLog("License new of type ". getLicenseType($licenseTypeNew));

if ($licenseTypeOld == $licenseTypeNew) {
	copyLicense($licenseNew);
	writeLog("License new installed of type ". getLicenseType($licenseTypeNew));
}
else if ($licenseTypeOld < $licenseTypeNew) {
	copyLicense($licenseOld);
	writeLog("License old installed of type ". getLicenseType($licenseTypeOld));
}
else {
	copyLicense($licenseNew);
	writeLog("License new installed of type ". getLicenseType($licenseTypeNew));
}
exit(0);

function checkLicenseType($licenseFile)
{
	/* Lincetype:
		- 0 : Premium, custom, other valid
   		- 1 : Free
   		- 2 : Not valid
	*/	
	copyLicense($licenseFile);
	$cmd = "/usr/local/opmon/utils/license/get_license_properties.php";
	$cmdReturn = array();
	$retCode = 0;
	$ret = exec($cmd, $cmdReturn, $retCode);

	if ($retCode > 0) { // Invalid license or expired license
		return 2;
	}
	$licenseDetails = json_decode($ret);
	if ($licenseDetails === false) { // Invalid license
		return 2;
	}


	if (isset($licenseDetails->LicenseType->value) && ($licenseDetails->LicenseType->value == "Free") ) {
		return 1;
	}
	else if (isset($licenseDetails->LicenseType->value)) {
		return 0;
	}

}

function copyLicense($licenseFile)
{
	$filename = '/usr/local/opmon/lic/opmon-lic.txt';
	@copy($licenseFile, $filename);
	@exec('chmod 664 ' . $filename );
	@exec('chown apache.apache ' . $filename );
}

function getLicenseType($licenseType)
{
	if ($licenseType == 0) {
		return "Custom/Premium/Pro";
	}
	else if ($licenseType == 1) {
		return "Free";
	}
	else {
		return "Invalid license";
	}
}

function writeLog($msg) {
    global $logFile;

    $initial = new DateTime('NOW');
    $date_log=$initial->format('Y-m-d H:i:s');
    unset($initial);
    $FILE = fopen($logFile, "a+");
    if ($FILE !== false) {
    	print $date_log." - ".$msg."\n";
		fputs($FILE, $date_log." - ".$msg."\n");
        flush($FILE);
        fclose($FILE);
    }
}


?>

