<?php

include("/usr/local/opmon/etc/config.php");

use \Database\Driver\DefaultDB as DefaultDB;
use \ForceUTF8\Encoding;

$db = new DefaultDB('opcfg');
$db->prepare("set names latin1");
$db->execute();
$db->prepare("select host_id, host_name, alias from nagios_hosts");
$db->execute();
$data = $db->fetchAll(DefaultDB::FETCH_OBJ);
foreach ($data as $d) {
    $str = Encoding::toUTF8($d->host_name);
    $alias = Encoding::toUTF8($d->alias);
    $up = new DefaultDB('opcfg');
    $up->prepare("update nagios_hosts set host_name = ?, alias = ? where host_id = ?");
    $up->execute(array($str, $alias, $d->host_id));
}

$db->prepare(
    "select checkcommandparameter_id, parameter from nagios_hosts_check_command_parameters"
);
$db->execute();
$data = $db->fetchAll(DefaultDB::FETCH_OBJ);
foreach ($data as $d) {
    $str = Encoding::toUTF8($d->parameter);
    $up = new DefaultDB('opcfg');
    $up->prepare(
        "update nagios_hosts_check_command_parameters set parameter = ? where checkcommandparameter_id = ?"
    );
    $up->execute(array($str, $d->checkcommandparameter_id));
}

$db->prepare("select service_id, service_description from nagios_services");
$db->execute();
$data = $db->fetchAll(DefaultDB::FETCH_OBJ);
foreach ($data as $d) {
    $str = Encoding::toUTF8($d->service_description);
    $up = new DefaultDB('opcfg');
    $up->prepare(
        "update nagios_services set service_description = ? where service_id = ?"
    );
    $up->execute(array($str, $d->service_id));
}

$db->prepare(
    "select checkcommandparameter_id, parameter from nagios_services_check_command_parameters"
);
$db->execute();
$data = $db->fetchAll(DefaultDB::FETCH_OBJ);
foreach ($data as $d) {
    $str = Encoding::toUTF8($d->parameter);
    $up = new DefaultDB('opcfg');
    $up->prepare(
        "update nagios_services_check_command_parameters set parameter = ? where checkcommandparameter_id = ?"
    );
    $up->execute(array($str, $d->checkcommandparameter_id));
}

$db = new DefaultDB('opmon4');
$db->prepare("set names latin1");
$db->execute();
$db->prepare(
    "select id, scat_name from scats"
);
$db->execute();
$data = $db->fetchAll(DefaultDB::FETCH_OBJ);
foreach ($data as $d) {
    $str = Encoding::toUTF8($d->scat_name);
    $up = new DefaultDB('opmon4');
    $up->prepare("update scats set scat_name = ? where id = ?");
    $up->execute(array($str, $d->id));
}

$db = new DefaultDB('opmon4');
$db->prepare("set names latin1");
$db->execute();
$db->prepare(
    "select id, var, value from dashboards where var='name'"
);
$db->execute();
$data = $db->fetchAll(DefaultDB::FETCH_OBJ);
foreach ($data as $d) {
    $str = Encoding::toUTF8($d->value);
    if ($str === $d->value) {
	continue;
    }
    $up = new DefaultDB('opmon4');
    $up->prepare("update dashboards set value = ? where id = ? and var = 'name'");
    $up->execute(array($str, $d->id));
}

$db = new DefaultDB('opmon4');
$db->prepare("set names latin1");
$db->execute();
$db->prepare(
    "select id, item_name from interface_shortcut_items where link is not null"
);
$db->execute();
$data = $db->fetchAll(DefaultDB::FETCH_OBJ);
foreach ($data as $d) {
    $str = Encoding::toUTF8($d->item_name);
    if ($str === $d->item_name) {
	continue;
    }
    $up = new DefaultDB('opmon4');
    $up->prepare("update interface_shortcut_items set item_name = ? where id = ?");
    $up->execute(array($str, $d->id));
}
