<?php
error_reporting(E_ALL|E_STRICT);

require_once("/usr/local/opmon/etc/config.php");

use Database\Driver\DefaultDB;

$db = new DefaultDB();

print "Migrate snmp_communities";

$db->prepare("SELECT * FROM opcfg.snmp_communities");
$db->execute();
$authArray = $db->fetchAll(DefaultDB::FETCH_ASSOC);

$db->getConnection()->setAttribute(PDO::MYSQL_ATTR_USE_BUFFERED_QUERY, false);

foreach ($authArray as $auth) {
    if (array_key_exists('name', $auth)) {
        if (! empty($auth['name'])) {
            continue;
        }
    }

    if (preg_match('/^(1|2c)$/', $auth['snmp_version'])) {
        $newName = $auth['community_id']."-".$auth['community'];
    }

    if ($auth['snmp_version'] == "3") {
        $newName = $auth['community_id'];
        if (! is_null($auth['security_username'])) {
            $newName .= "-".$auth['security_username'];
        } elseif (! is_null($auth['community'])) {
            $newName .= "-".$auth['community'];
        }
    }

    $db->prepare(
        "UPDATE opcfg.snmp_communities SET name = ? WHERE community_id = ?"
    );
    $db->execute(
        array($newName, $auth['community_id'])
    );
    print ".";
}

print " Done.".PHP_EOL;

print "Migrate credentials";

$db->prepare("SELECT * FROM opcfg.credentials");
$db->execute();
$authArray = $db->fetchAll(DefaultDB::FETCH_ASSOC);

$db->getConnection()->setAttribute(PDO::MYSQL_ATTR_USE_BUFFERED_QUERY, false);

foreach ($authArray as $auth) {
    if (array_key_exists('name', $auth)) {
        if (! empty($auth['name'])) {
            continue;
        }
    }

    $newName = $auth['credential_id']."-".$auth['username'];

    $db->prepare(
        "UPDATE opcfg.credentials SET name = ? WHERE credential_id = ?"
    );
    $db->execute(
        array($newName, $auth['credential_id'])
    );
    print ".";
}

print " Done.".PHP_EOL;
