<?php

include_once('/usr/local/opmon/etc/config.php');

$runningAgain = 1;
function main() {

	global $runningAgain;

	print "::: Migrate Bookmarks and Shortcuts :::\n";

	// Fix Favorite Links
	print "Fixing bookmarks ...\n";
	$ret = do_query("select * from interface_user_favorites",DBOPMON,OPDB_FETCH_OBJ);
	fixFavLinks($ret);

	// Fix Shortcut Links
	print "Fixing shortcuts ...\n";
	if (!$runningAgain) {
		$ret = do_query("select * from interface_shortcut_items where system = 0 and shortcut_id = 1",DBOPMON,OPDB_FETCH_OBJ);
		fixShortcutLinks($ret);
	}

}

function fixFavLinks( $ret ) {
	
	global $runningAgain;

	$custom = array();
	while (!$ret->EOF) {
		$obj = $ret->fields;
		if ($obj->link == NULL) {
			$ret->MoveNext();
			continue;
		}

		$arr = array();
		if (preg_match("/statusgrid\/action\/(\S*)\/\?/",$obj->link,$arr)) {
			if (!isset($custom[$arr[1]]))
				$custom[$arr[1]] = array();
			$custom[$arr[1]][] = $obj;
		}

		$ret->MoveNext();
	}
	$ret->Close();

	if (count($custom)) {
		foreach($custom as $key => $arr) {
			foreach($arr as $obj) {
				$preg = array();
				if (preg_match("/filterString=([^&]*)/",$obj->link,$preg)) {
					$runningAgain = 0;
					$string = str_replace("&fromShortcut=1","",$preg[1]);
					$pieces = explode("|",$string);
					$filter = new stdClass();
					foreach($pieces as $x) {
						list($prop,$value) = split(";",$x);
						if ($prop == 'name' || $prop == 'host_name')
							$prop = 'search';
						if (isset($filter->$prop)) {
							if (!is_array($filter->$prop)) {
								$tmp = $filter->$prop;
								$filter->$prop = array();
								array_push($filter->$prop,$tmp);
							}
							array_push($filter->$prop,$value);
						} else {
							$filter->$prop = $value;
						}
					}
					$f = new stdClass();
					$f->searchPanel = 1;
					$f->filter = $filter;
					$url = "/opmon/seagull/www/index.php/statusgrid/action/$key/?";
					$url .= http_build_query($f);

					print "\t>>> Updating - Contact ID: {$obj->contact_id} Name: {$obj->name}\n";
					$query = "update interface_user_favorites set link = '$url' where contact_id = '{$obj->contact_id}' and id = '{$obj->id}'";
					do_query($query,DBOPMON);

				}
			}
		}
	}

}

function fixShortcutLinks( $ret ) {
	
	$custom = array();
	while (!$ret->EOF) {
		$obj = $ret->fields;
		if ($obj->link == NULL) {
			$ret->MoveNext();
			continue;
		}

		$arr = array();
		if (preg_match("/statusgrid\/action\/(\S*)\/\?/",$obj->link,$arr)) {
			if (strstr($arr[1],"host") !== false)
				$arr[1] = "hosts";
			if (strstr($arr[1],"service") !== false)
				$arr[1] = "services";
			if (!isset($custom[$arr[1]]))
				$custom[$arr[1]] = array();
			$custom[$arr[1]][] = $obj;
		}

		$ret->MoveNext();
	}
	$ret->Close();

	if (count($custom)) {

		foreach($custom as $key => $arr) {
			foreach($arr as $obj) {

				print "\t>>> $key - Creating custom folder...\n";
				$tmpCustom = new stdClass();
				$tmpCustom->item_name = "Custom";
				$tmpCustom->system = 0;
				$tmpCustom->parentId = 0;
				
				$shortcut_id = getShortcutId($key);
				if ($shortcut_id === false) { continue; }

				$parentId = add_shortcut_item($shortcut_id,$tmpCustom);

				$preg = array();
				if (preg_match("/filterString=([^&]*)/",$obj->link,$preg)) {
					$runningAgain = 0;
					$string = str_replace("&fromShortcut=1","",$preg[1]);
					$pieces = explode("|",$string);
					$filter = new stdClass();
					foreach($pieces as $x) {
						list($prop,$value) = split(";",$x);
						if ($prop == 'name' || $prop == 'host_name')
							$prop = 'search';
						if (isset($filter->$prop)) {
							if (!is_array($filter->$prop)) {
								$tmp = $filter->$prop;
								$filter->$prop = array();
								array_push($filter->$prop,$tmp);
							}
							array_push($filter->$prop,$value);
						} else {
							$filter->$prop = $value;
						}
					}
					$f = new stdClass();
					$f->searchPanel = 1;
					$f->filter = $filter;
					$url = "/opmon/seagull/www/index.php/statusgrid/action/$key/?";
					$url .= http_build_query($f);

					print "\t>>> Updating $key - Name: {$obj->item_name}\n";
					$tmpCustom = new stdClass();
					$tmpCustom->item_name = $obj->item_name;
					$tmpCustom->system = 0;
					$tmpCustom->parentId = $parentId;
					$tmpCustom->hrefDefault = $url;
					add_shortcut_item($shortcut_id,$tmpCustom);

				}
			}
		}
	}

}

function getShortcutId( $name ) {

	$query = "select id from interface_shortcut_names where shortcut_name = 'statusgrid_$name'";
	$ret = do_query($query,DBOPMON);
	if ($ret->RecordCount()) {
		return $ret->fields['id'];
	} else {
		return false;
	}

}

main();

?>
