<?php

include "/usr/local/opmon/etc/config.php";

use Database\Driver\DefaultDB as DB;

$db = new DB("opmon4");

$query = 'SELECT * FROM scheduler';
$db->prepare($query);
$db->execute();

if ($db->rowCount() > 0) {
    print "Scheduled reports already migrated.".PHP_EOL;
    exit;
}

print "Getting scheduled reports.".PHP_EOL;
$query = 'SELECT id, contact_id, report_id FROM scheduled_reports';
$db->prepare($query);
$db->execute();

if ($db->rowCount() === 0) {
    print "Not found scheduled reports.".PHP_EOL;
    exit;
}

$scheduled = $db->fetchAll(DB::FETCH_OBJ);

foreach ($scheduled as $sched) {
    print "Migrating report id: {$sched->report_id}.".PHP_EOL;

    print "Getting type from report...";
    $query = 'SELECT value FROM reports
        WHERE id = :report_id AND var = :type';
    $db->prepare($query);
    $db->execute(
        array(
            ':report_id' => $sched->report_id,
            ':type' => "formTo"
        )
    );
    $type = $db->fetch(DB::FETCH_OBJ);

    print "Setting report type...";
    $query = 'UPDATE scheduled_reports
        SET report_type = :report_type WHERE report_id = :id';
    $db->prepare($query);
    $db->execute(
        array(
            ':report_type' => $type->value,
            ':id' => $sched->report_id
        )
    );
    print "Done.".PHP_EOL;

    print "Getting association between report and scheduling...";
    $query = 'select id from scheduled_reports
        where report_id = :report_id order by id asc limit 1';
    $db->prepare($query);
    $db->execute(
        array(
            ':report_id' => $sched->report_id,
        )
    );
    $firstId = $db->fetch(DB::FETCH_OBJ);

    print "Setting association between report and scheduling...";
    $query = 'INSERT INTO scheduler
        (contact_id, schedule_id) VALUES (:contact_id, :schedule_id)';
    $db->prepare($query);
    $db->execute(
        array(
            ':contact_id' => $sched->contact_id,
            ':schedule_id' => $firstId->id
        )
    );
    print "Done.".PHP_EOL;
}

print "deleting duplicate entries by report...";
$query = 'delete from scheduled_reports
    where id not in (select * from
    (select id from scheduled_reports group by report_id)
    as tmp)';
$db->prepare($query);
$db->execute();
print "Done.".PHP_EOL;

print "Removing column contact_id from table...";
$query = 'ALTER TABLE scheduled_reports DROP COLUMN contact_id;';
$db->prepare($query);
$db->execute();
print "Finish.".PHP_EOL;
