<?php
include "/usr/local/opmon/etc/config.php";
set_logged_user('opmonadmin');

$query="SELECT * from opcfg.opmon_rtg order by host_id,service_id;";

$result = do_query( $query, DBOPMON );
print "Migrating data from netperf to opperf\n";
while(!$result->EOF) {
	$row = array_to_object($result->fields);
	print "Migrating {$row->host_id} - {$row->service_id} - {$row->ifname}...";
	
	$host_id=$row->host_id;
	$service_id=$row->service_id;
	$metric_id_Download=get_or_insert_metric_id($host_id, $service_id, "Download");
	$metric_id_InDiscards=get_or_insert_metric_id($host_id, $service_id, "InDiscards");
	$metric_id_InErrors=get_or_insert_metric_id($host_id, $service_id, "InErrors");
	$metric_id_Upload=get_or_insert_metric_id($host_id, $service_id, "Upload");
	$metric_id_OutDiscards=get_or_insert_metric_id($host_id, $service_id, "OutDiscards");
	$metric_id_OutErrors=get_or_insert_metric_id($host_id, $service_id, "OutErrors");
	

	$sql="CREATE TABLE IF NOT EXISTS opperf.service_perf_$host_id like opperf.service_perf;";
	$result_opnetperf = do_query( $sql, DBOPMON );
	$result_opnetperf->Close();
	

	$sql="select entry_time, ROUND((ifInOctets/polling_time/1000*10),2) as ifInOctets, ROUND((ifInDiscards/polling_time/1000*10),2) as ifInDiscards, ROUND((ifInErrors/polling_time/1000*10),2) as ifInErrors, ROUND((ifOutOctets/polling_time/1000*10),2) as ifOutOctets, ROUND((ifOutDiscards/polling_time/1000*10),2) as ifOutDiscards, ROUND((ifOutErrors/polling_time/1000*10),2) as ifOutErrors from opnetperf.netperf_$host_id where service_id=$service_id order by entry_time;";
	//print "$sql\n";
	$result_opnetperf = do_query( $sql, DBOPMON );
	while(!$result_opnetperf->EOF) {
		$row = array_to_object($result_opnetperf->fields);

		$sql_opperf="INSERT IGNORE INTO opperf.service_perf_$host_id values ('{$row->entry_time}','$service_id','$metric_id_Download','{$row->ifInOctets}','','');";
		do_query($sql_opperf, DBOPMON );
		$sql_opperf="INSERT IGNORE INTO opperf.service_perf_$host_id values ('{$row->entry_time}','$service_id','$metric_id_InDiscards','{$row->ifInDiscards}','','');";
		do_query($sql_opperf, DBOPMON );
		$sql_opperf="INSERT IGNORE INTO opperf.service_perf_$host_id values ('{$row->entry_time}','$service_id','$metric_id_InErrors','{$row->ifInErrors}','','');";
		do_query($sql_opperf, DBOPMON );
		$sql_opperf="INSERT IGNORE INTO opperf.service_perf_$host_id values ('{$row->entry_time}','$service_id','$metric_id_Upload','{$row->ifOutOctets}','','');";
		do_query($sql_opperf, DBOPMON );
		$sql_opperf="INSERT IGNORE INTO opperf.service_perf_$host_id values ('{$row->entry_time}','$service_id','$metric_id_OutDiscards','{$row->OutDiscards}','','');";
		do_query($sql_opperf, DBOPMON );
		$sql_opperf="INSERT IGNORE INTO opperf.service_perf_$host_id values ('{$row->entry_time}','$service_id','$metric_id_OutErrors','{$row->OutErrors}','','');";
		do_query($sql_opperf, DBOPMON );
		$result_opnetperf->MoveNext();
	}
	$result_opnetperf->Close();
	print " done\n";

	$result->MoveNext();
}
$result->Close();	

print "Done\n";

exit(0);

function get_metric_id($host_id, $service_id, $metric)
{
	$metric_id=-1;
	$sql="SELECT metric_id from opcfg.service_metric where host_id='$host_id' AND service_id='$service_id' AND metric='$metric';";
	$result = do_query( $sql, DBOPMON );
	if ($result->RecordCount()>0) {
		$row = array_to_object($result->fields);
		$metric_id=$row->metric_id;
	}
	$result->Close();
	return($metric_id);
}

function get_or_insert_metric_id($host_id, $service_id, $metric)
{
	$metric_id=get_metric_id($host_id, $service_id, $metric);
	if ($metric_id<0) {
		$sql="INSERT IGNORE INTO opcfg.service_metric values ('','$host_id', '$service_id', '$metric','kbps','0','');";
		$result = do_query( $sql, DBOPMON );
		$result->Close();
		$metric_id=get_metric_id($host_id, $service_id, $metric);
	}
	return($metric_id);
}

?>
