#!/usr/bin/php
<?php
include("/usr/local/opmon/etc/config.php");
set_logged_user('opmonadmin');

$notokudb_databases = array(
    'seagull',
    'information_schema',
    'performance_schema',
    'mysql',
    'teste'
);

$notokudb_tables = array(
    'opdocs_contacts',
    'opdocs_comunication_links',
    'opdocs_resources',
    'opdocs_list',
    'host_status',
    'service_status',
    'host_contacts',
    'service_contacts',
    'hostgroup_membership',
    'servicegroup_membership'
);

print "Migrating databases to InnoDB\n";

$all_dbs = get_all_databases();
foreach($all_dbs as $db) {
	if (in_array($db,$notokudb_databases) === TRUE) {
		print "Skip database $db\n";
		continue;
	}
	$tables = get_all_table_names_db($db);
	foreach ($tables as $table) {
		if (in_array($table,$notokudb_tables) === TRUE) {
			$sql = "ALTER TABLE $db.$table ENGINE=INNODB;";
		} else {
			$sql = "ALTER TABLE $db.$table ENGINE=INNODB;";
		}

		print "$sql ...";
		$timeelapsed = time();
		$ret = do_query($sql, $db);
		$ret->Close(); 
		$timeelapsed = time() - $timeelapsed;
		print $timeelapsed."s done\n";
		/* Create index removed by tokudb migration */
		if ($db == "opperf") {
			$timeelapsed = time();
		        $sql = "DROP INDEX service_perf_idx_1 on opperf.$table;";
			do_query($sql, $db);
       			$sql = "create index service_perf_1_idx on opperf.$table (service_id,metric_id,entry_time);";
			print "$sql ... ";
			do_query($sql, $db);
			$timeelapsed = time() - $timeelapsed;
			print $timeelapsed."s done\n";
		}
	}

}
print "Migration Done\n";
exit(0);

/* Get all tables from a DB */
function get_all_table_names_db($dbname)
{
	$query="show tables;";
	$result = do_query($query,$dbname);

	$tables = array();
	while( !$result->EOF ) {
		$tables[]=array_shift($result->fields);
		$result->MoveNext();
	}
	$result->Close();
	return($tables);
}

/* Get all tables from a DB */
function get_all_databases()
{
	$query="show databases;";
	$result = do_query($query,"mysql");

	$tables = array();
	while( !$result->EOF ) {
		$tables[]=array_shift($result->fields);
		$result->MoveNext();
	}
	$result->Close();
	return($tables);
}

?>
