#!/usr/bin/php
<?php
include("/usr/local/opmon/etc/config.php");
set_logged_user('opmonadmin');

$notokudb_databases = array(
    //'seagull',
    'information_schema',
    'performance_schema',
    'mysql',
    'teste'
);

$notokudb_tables = array(
    /* opmon4 tables with constraints */
    'opdocs_contacts',
    'opdocs_comunication_links',
    'opdocs_resources',
    'opdocs_list',
    /* seagull tables with constraints */
    'block_assignment',
    'block' /*,
    'host_status',
    'service_status',
    'host_contacts',
    'service_contacts',
    'hostgroup_membership',
    'servicegroup_membership' */
);

print "Migrating databases to TokuDB\n";

$all_dbs = get_all_databases();
foreach($all_dbs as $db) {
	if (in_array($db,$notokudb_databases) === TRUE) {
		print "Skip database $db\n";
		continue;
	}
	$tables = get_all_table_names_db($db);
	foreach ($tables as $table) {
		if (in_array($table,$notokudb_tables) === TRUE) {
			$engine = check_table_engine($table, $db);
			if ($engine === false or $engine == "InnoDB" ) {
				print "Skipping exeption $engine $db.$table already in $engine\n";
				continue;
			}
			$sql = "ALTER TABLE $db.$table ENGINE = InnoDB;";
		} else {
			$engine = check_table_engine($table, $db);
			if ($engine === false or $engine == "TokuDB" ) {
				print "Skipping $db.$table already in $engine\n";
				continue;
			}
			$timeelapsed = time();
			if ($db == "opperf") {
				$sql = "alter table $db.$table drop index service_perf_1_idx;";
				$ret = do_query($sql, $db);
				$sql = "alter table $db.$table drop primary key;";
				$ret = do_query($sql, $db);
			}
			$sql = "ALTER TABLE $db.$table ENGINE = TokuDB compression='tokudb_snappy';";
		}
		print "$sql ...";
		$ret = do_query($sql, $db);
		$ret->Close();
		/* Remove unused index from oppert tables and add new primary key */
		if ($db == "opperf") {
			$sql = "drop index if exists service_perf_1_idx on ".$db.".".$table.";";
			$ret = do_query($sql, $db);
			$ret->Close();

			/* create new primary key */
			$sql = "alter table $db.$table add primary key (service_id, metric_id, entry_time);";
			$ret = do_query($sql, $db);

		}
		$timeelapsed = time() - $timeelapsed;
		print $timeelapsed."s done\n";
	}

}
print "Migration Done\n";
exit(0);

/* returns the size of the table in MB */
function check_table_engine($table_name, $dbname)
{
        $ret = false;
        $tables_exists=check_table_exists($table_name, $dbname);
        if ($tables_exists===FALSE)
                return $ret;

        $query="SELECT ENGINE as engine FROM information_schema.TABLES  WHERE table_schema = '$dbname' and table_name = '$table_name';";
        $result = do_query($query,$dbname,OPDB_FETCH_OBJ);
        if ($result->RecordCount() > 0) {
                $obj=$result->fields;
                $ret = $obj->engine;
        }
        return($ret);
}

function check_table_exists($table_name, $dbname)
{
        $query="show tables;";
        $result = do_query($query,$dbname);

        $tables = array();
        while( !$result->EOF ) {
                $tables[]=array_shift($result->fields);
                $result->MoveNext();
        }
        $result->Close();
        $found=array_search($table_name, $tables);
        return($found);
}

/* Get all tables from a DB */
function get_all_table_names_db($dbname)
{
	$query="show tables;";
	$result = do_query($query,$dbname);

	$tables = array();
	while( !$result->EOF ) {
		$tables[]=array_shift($result->fields);
		$result->MoveNext();
	}
	$result->Close();
	return($tables);
}

/* Get all tables from a DB */
function get_all_databases()
{
	$query="show databases;";
	$result = do_query($query,"mysql");

	$tables = array();
	while( !$result->EOF ) {
		$tables[]=array_shift($result->fields);
		$result->MoveNext();
	}
	$result->Close();
	return($tables);
}

?>
