<?php
include "/usr/local/opmon/etc/config.php";
set_logged_user("opmonadmin");


function get_nedi_devs() {
	$q = "SELECT devip, device ".
	     "FROM devices";
	
	$devs = array();
	$ret = do_query($q, "nedi", OPDB_FETCH_OBJ);
	while(!$ret->EOF) {
		$ret->fields->devip = long2ip($ret->fields->devip);
		$devs[] = $ret->fields;
		$ret->MoveNext();
	}
	$ret->Close();
	return $devs;
}


function device_already_monitored($ip, $name) {
	$h = HostDiscovery::get_from_db_by_ips(array(
	    $ip
	));

	$ips = ($h === FALSE) ? array($ip) : array_unique(array_merge($h->get_ips(), array($ip)));
	$ipstr = implode("','", $ips);

	$q = "SELECT count(*) AS c ".
	     "FROM nagios_hosts ".
	     "WHERE address IN ('%s')";

	$q = sprintf(
	    $q,
	    $ipstr
	);

	$ret = do_query($q, DBOPCFG, OPDB_FETCH_OBJ);
	if ($ret->fields->c > 0) {
		$ret->Close();
		return TRUE;
	}
	$ret->Close();

	$q = "SELECT count(*) AS c ".
	     "FROM nagios_hosts ".
	     "WHERE host_name='%s'";
	$q = sprintf(
	    $q,
	    do_escape_string($name)
	);

	$ret = do_query($q, DBOPCFG, OPDB_FETCH_OBJ);
	if ($ret->fields->c > 0) {
		$ret->Close();
		return TRUE;
	}


	$ret->Close();
	return FALSE;
}


function import_new_host($nhost) {
	global $manager;

	$check_command_id = $manager->cfg->return_command_id_by_name("nao_monitorado");
	$period_id = $manager->cfg->return_period_id_by_name("24x7");
	$hash = array(
	    "host_name" => $nhost->device,
	    "max_check_attempts" => 5,
	    "check_interval" => 5,
	    "retry_interval" => 1,
	    "address" => $nhost->devip,
	    "alias" => "Host inserido via linha de comando",
	    "check_command" => $check_command_id,
	    "check_period" => $period_id
	);

	$ret = $manager->cfg->add_host($hash);
	$host_id = $manager->cfg->return_host_id_by_name($nhost->device);
	$hash = array(
	    "host_id" => $host_id,
	    "service_description" => "Host-Alive",
	    "max_check_attempts" => 5,
	    "normal_check_interval" => 5,
	    "retry_check_interval" => 1,
	    "check_command" => $check_command_id,
	    "check_period" => $period_id,
	    "notification_period" => $period_id
	);
	$manager->cfg->add_service($hash);

	$service_id = $manager->cfg->return_service_id_by_host_and_description(
	    $host_id,
	    "Host-Alive"
	);

	$cgid = $manager->cfg->return_contactgroup_id_by_name("opmon-admins");
	$manager->cfg->add_service_contactgroup($service_id, $cgid);
	$manager->cfg->add_host_contactgroup($host_id, $cgid);

	print $nhost->device." - ".$nhost->devip."\n";

}


$manager = new ConfigManager();
$nedi_hosts = get_nedi_devs();
foreach($nedi_hosts as $nhost) {

	if (device_already_monitored($nhost->devip, $nhost->device) === TRUE) {
		continue;
	}
	import_new_host($nhost);

}


?>
