#!/usr/bin/php
<?php
include("/usr/local/opmon/etc/config.php");
set_logged_user('opmonadmin');

if (is_nagios_running() !== true) {
    onc_log("OpMon is not running");
    exit(0);
}

$onc_url = "http://onc.opservices.com/onc.php";
$opts = array('http' =>
               array(
               'method'  => 'GET',
               'timeout' => 60
                        )
                );
$context = stream_context_create($opts);
$json_data = file_get_contents($onc_url, false, $context);
$data = json_decode($json_data);
$ret = 0;
if ($data!==NULL && !empty($data))  {
	$ret = writeDB($data);
}
else {
	$ret = 2;
}
if ($ret == 0) {
	onc_log("Message type {$data->type} ID {$data->id} already in database, update it");
}
else if ($ret == 1) {
	onc_log("New message type {$data->type} ID {$data->id} added to database");
}
else if ($ret == 2) {
	onc_log("Endpoint returned no messages");
}
else {
	onc_log("Error querying database, nothing done");
}
return(0);

function writeDB($obj = null) {
	$ret = 0;
	if ($obj == null || !isset($obj->type)) {
		return;
	}

	$type = convertType($obj->type);
	$sql = "SELECT * from notification_message WHERE ";
	$sql.= "external_id = '{$obj->id}' AND ";
	$sql.= "type = '{$type}';";
	$result = do_query($sql, DBOPMON);
	$found_records = $result->RecordCount();
	if ($found_records === false) {
		return(-1);
	}
	else if ($found_records >= 0) { // Insert / update message
		preg_match_all('#\bhttps?://[^,\s()<>]+(?:\([\w\d]+\)|([^,[:punct:]\s]|/))#', $obj->message, $match);
		$anchor = '';
		$msg = $obj->message;
		if (isset($match[0][0])) {
			$anchor = $match[0][0];
			$msg = str_replace($anchor, '', $obj->message);
		}
		$msg = trim($msg);
		$msg = do_escape_string($msg);
		$anchor = do_escape_string($anchor);
		$external_id = do_escape_string($obj->id);

		$sql = "SET NAMES 'utf8mb4' COLLATE 'utf8mb4_unicode_ci';";
		do_query($sql, DBOPMON);
		if ($found_records == 0) {
			$sql = "INSERT INTO notification_message (type, text, external_id, lang, anchor) VALUES ";
			$sql.= "('{$type}', '{$msg}', '{$external_id}', 'pt_BR','{$anchor}')";
			$ret = 1;
			//sendpush($msg." ".$anchor);
		}
		else {
			$sql = "UPDATE notification_message set text='{$msg}',anchor='{$anchor}' ";
			$sql.= "WHERE type='{$type}' AND external_id = '{$external_id}';";
		}
		$db = new \Database\Driver\DefaultDB(DBOPMON);
		$db->prepare("SET NAMES 'utf8mb4' COLLATE 'utf8mb4_unicode_ci';");
		$db->execute();
		$db->prepare($sql);
		$db->execute();
		return($ret);
	}
	return(0);
}

function convertType($type) {
	$ret_type = NULL;
	switch($type) {
		case 'twitter':
			$ret_type = 3;
			break;
		case 'version':
			$ret_type = 0;
			break;
		case 'prediction':
			$ret_type = 1;
			break;
		case 'kb':
			$ret_type = 2;
			break;
	}
	return $ret_type;
}


function onc_log($msg)
{
    $msg = str_replace("\n", "", $msg);

    $date = new DateTime();
    $dateFormated = $date->format('Y-m-d H:i:s');

    $logFile = fopen("/var/log/onc-messages.log", "a");

    $text = "[$dateFormated] $msg".PHP_EOL;
    fprintf($logFile, $text);
    fclose($logFile);
    print $text;
}

function sendpush($msg) {
	require_once("/usr/local/opmon/share/onc/libs/autoload.php");

    $message = new StdClass();
    $message->icon = "ic_stat_0";
    $message->color = '#ff4a00';
	$message->text = $msg;
    $contacts = get_contacts();
    foreach ($contacts as $contact) {
        $user = ONCContact::get_contact_by_name($contact->get_contact_name());
        $token = new ONCToken();
        $token->setContactId($user->get_contact_id());
        $tokens = $token->getAllByContactId();

        if (empty($tokens)) {
            continue;
        }

        try {
            $notify = ONCNotification::create_notification($message, $tokens);
            $response = ONCNotification::send_notification($notify);
        } catch (Exception $e) {
            print $e->getMessage().PHP_EOL;
        }
    }
}

?>
