#!/usr/bin/perl
#

use DBI;
use POSIX;

$VERSION="2.0";

$DBSERVER="localhost";
$DBNAME="opmon";
$DBUSER="root";
$DBPASS="oppass";

print "\nhost_change_name.pl Version $VERSION\n";

($old_hostname, $new_hostname)=@ARGV;

if ($#ARGV<1) {
	print "\nUsage: host_change_name.pl <old_hostname> <new_hostname>\n\n";
	exit(0);
}

print "\n\n";
print "Faca backup dos logs do opmon e pare o opmon antes rodar esse script\n";
print "\n\n";
print "Pressione <ENTER> para continuar\n";
print "\n\n";
$nada=<STDIN>;

$opmon_root_dir="/usr/local/opmon";
$opmon_logs_dir=$opmon_root_dir."/var/archives/";
$opmon_log_dir=$opmon_root_dir."/var/";

opendir(DIR, "$opmon_logs_dir");
@files=readdir(DIR);
close(DIR);

#change_host_name("/usr/local/opmon/var/archives/opmon-03-18-2004-00.log", $old_hostname, $new_hostname);
#exit(0);

$totalCount=0;
foreach $file (@files) {
	if ( ($file eq ".") or ($file eq "..") ) {
		next;
	}
	#print "$file\n";
	$temp=$opmon_logs_dir.$file;
	$hits=0;
	$hits=change_host_name($temp, $old_hostname, $new_hostname);
	$totalCount=$totalCount+$hits;
}

# checks current opmon.log
$temp=$opmon_log_dir."opmon.log";
$hits=0;
$hits=change_host_name($temp, $old_hostname, $new_hostname);
$totalCount=$totalCount+$hits;
print "\nTotal lines changed: $totalCount\n\n";

print "Updating database\n";

print "Connecting database opmon...";
$dbh = DBI->connect ( "dbi:mysql:dbname=$DBNAME;host=$DBSERVER", "$DBUSER", "$DBPASS");
if ( !defined $dbh ) {
        die "Cannot connect to database!\n";
}
print "done\n";

# host_alert
print "Updating host_alert...";
$sql="update host_alert set hostname='$new_hostname' where hostname='$old_hostname'";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

# host_downtime_alert
print "Updating host_downtime_alert...";
$sql="update host_downtime_alert set hostname='$new_hostname' where hostname='$old_hostname'";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

# service_alert
print "Updating service_alert...";
$sql="update service_alert set hostname='$new_hostname' where hostname='$old_hostname'";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

# service_downtime_alert
print "Updating service_downtime_alert...";
$sql="update service_downtime_alert set hostname='$new_hostname' where hostname='$old_hostname'";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

# acoes
print "Updating acoes...";
$sql="update acoes set hostname='$new_hostname' where hostname='$old_hostname'";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

# informacoes
print "Updating informacoes...";
$sql="update informacoes set hostname='$new_hostname' where hostname='$old_hostname'";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

$dbh->disconnect();

# perfparse
print "Connecting database perfparse...";
$dbh = DBI->connect ( "dbi:mysql:dbname=perfparse;host=$DBSERVER", "$DBUSER", "$DBPASS");
if ( !defined $dbh ) {
        die "Cannot connect to database!\n";
}
print "done\n";

# perfdata_service_metric
print "Updating perfdata_service_metric...";
$sql="update perfdata_service_metric set host_name='$new_hostname' where host_name='$old_hostname'";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

# perfdata_service
print "Updating perfdata_service...";
$sql="update perfdata_service set host_name='$new_hostname' where host_name='$old_hostname'";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

# remove "-" from hostname for perfdata table name compositon
$temp1=replaceCaracter("-","_",$old_hostname);
$temp2=replaceCaracter("-","_",$new_hostname);

$old_table_name="perfdata_service_bin_".$temp1;
$new_table_name="perfdata_service_bin_".$temp2;

print "Renaming $old_table_name to $new_table_name...";
$sql="alter table $old_table_name rename $new_table_name";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

# perfdata_service_$new_table_name
print "Updating $new_table_name...";
$sql="update $new_table_name set host_name='$new_hostname' where host_name='$old_hostname'";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

$dbh->disconnect();

exit(0);

sub replaceCaracter {
	local ($oldCaracter, $newCaracter, $stringChange)=@_;

	local $newstring="";
	@parts=split(//,$stringChange);
	foreach $caracter (@parts) {
		if ($oldCaracter eq $caracter) {
			$newstring=$newstring.$newCaracter;
		}
		else {
			$newstring=$newstring.$caracter;
		}
	}
	return($newstring);
}

sub change_host_name {
	local ($filename,$old_hostname, $new_hostname)=@_;
	open(FILE, $filename);
	@lines=<FILE>;
	close(FILE);
	
	$new_file="/tmp/opmon-host_change_name.log";
	open(NEWFILE,">$new_file");
	$count=0;
	foreach $line (@lines) {
		chop($line);
		$search_pattern1="HOST ALERT";
		$search_pattern11="INITIAL HOST STATE";
		$search_pattern12="CURRENT HOST STATE";
		$search_pattern2="SERVICE ALERT";
		$search_pattern21="INITIAL SERVICE STATE";
		$search_pattern22="CURRENT SERVICE STATE";
		$search_pattern3="HOST FLAPPING ALERT";
		$search_pattern4="SERVICE FLAPPING ALERT";
		$search_pattern5="HOST NOTIFICATION";
		$search_pattern6="SERVICE NOTIFICATION";
		if ( ($line=~/$search_pattern1/) or ($line=~/$search_pattern2/) or 
			  ($line=~/$search_pattern11/) or ($line=~/$search_pattern12/) or 
			  ($line=~/$search_pattern21/) or ($line=~/$search_pattern22/) or 
		     ($line=~/$search_pattern3/) or ($line=~/$search_pattern4/) or
		     ($line=~/$search_pattern5/) or ($line=~/$search_pattern6/) ) {
			@parts=split(/[:;]/, $line);
			$indexHostname=1;
			if ( ($parts[0]=~$search_pattern1) or ($parts[0]=~$search_pattern2) or
			     ($line=~/$search_pattern11/) or ($line=~/$search_pattern12/) or
			     ($line=~/$search_pattern21/) or ($line=~/$search_pattern22/) or
			     ($parts[0]=~$search_pattern3) or ($parts[0]=~$search_pattern4) ) {
				$indexHostname=1;
			}
			elsif ( ($parts[0]=~$search_pattern5) or ($parts[0]=~$search_pattern6) ) {
				$indexHostname=2;
			}
			# if split found more then 2 parts and the second is our hostname
			$tempHostname=trimSpaces($parts[$indexHostname]);
			if ( ($#parts >1 ) and ($tempHostname eq $old_hostname) ) {
				#print "$parts[0] $parts[1]\n";
				$new_line="";
				for ($i = 0; $i <= $#parts; ++$i)
				{
					if ( $i==0 ) {
						$new_line=$parts[$i].":";
					}
					elsif ( $i==$indexHostname ) {
						if ($indexHostname==1) { # this pattern has a space after hostname
							$new_line=$new_line." ".$new_hostname.";";
						}
						elsif ($indexHostname==2) { # this pattern has no space after hostname
							$new_line=$new_line.$new_hostname.";";
						}
					}
					else {
						if ($i==$#parts) { # last part of line doest have ";" at the end
							$new_line=$new_line.$parts[$i];
						}
						else {
							$new_line=$new_line.$parts[$i].";";
						}
					}
				}
				print NEWFILE $new_line."\n";;
				$count++;
			}
			else {
				print NEWFILE $line."\n";
			}
		}
		else {
			print NEWFILE $line."\n";
		}
	}
	close(NEWFILE);
	$temp="/bin/cp -f $new_file $filename";
	system($temp);
	$temp="/bin/sync";
	system($temp);
	unlink($new_file);
	print "$filename - $count hits\n";
	#print $new_file."\n";
	return($count);
}

sub trimSpaces {
	local ($string)=@_;
	
	$string =~s/^\s+//;
	$string =~s/\s+$//;
	
	return($string);
}
