#!/usr/bin/perl

use DBI;
use POSIX;


$version = 2.1;

$dbh = DBI->connect ( "dbi:mysql:dbname=opmon;host=localhost","root", "oppass");
if ( !defined $dbh ) {
	die "Cannot connect to database!\n";
}

$PATH_ARCHIEVES="/usr/local/opmon/var/archives/";

$filename="/usr/local/opmon/var/opmon.log";
#$filename="/usr/local/opmon/var/archives/opmon-08-28-2006-00.log";
log_import($filename);
exit(0);

opendir(DIR, "/usr/local/opmon/var/archives/");
@files=readdir(DIR);
close(DIR);
foreach $file (@files) {
   if ( ($file eq ".") or ($file eq "..") ) {
      next;
   }
   $filename=$PATH_ARCHIEVES.$file;
   print "Importing $filename...";
   log_import($filename);
   print "done.\n";
}
exit(0);

sub log_import {

	($logfile)=@_;
	
	open(FILE, $logfile);
	@lines=<FILE>;
	close(FILE);
	$sql="";
	$line="";

	foreach $line (@lines) {
		($desc, $rest)=split(/:/, $line);
		
		$search_pattern="SERVICE DOWNTIME ALERT";
		if ($desc=~/$search_pattern/) {
			($time_desc, $hostname, $servicename, $type,@tmp_extinfo)=split(/[:;]+/, $line);
			$extinfo = "@tmp_extinfo";
			$search_pattern="\[\]";
			($part1, $part2)=split(/\[/,$time_desc);
			($timestamp, $part2)=split(/\]/,$part2);
			$timestamp=dealsWithApostrofe($timestamp);
			$hostname=dealsWithApostrofe($hostname);
			$servicename=dealsWithApostrofe($servicename);
			$type=dealsWithApostrofe($type);
			$extinfo=dealsWithApostrofe($extinfo);
	   	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($timestamp);
			$wday++;
			$yday++;
			$isdst++;
			$mon++;
			$year+=1900;
			$longdate="$year-$mon-$mday $hour:$min:$sec";
			# converts text to codes to speed up and save space 
			$state_type=1;
			if ($type eq "STARTED") {
				$state_type=0;
			}
			if ($type eq "STOPPED") {
				$state_type=1;
			}
			if ($type eq "CANCELLED") {
				$state_type=2;
			}
			$sql="insert service_downtime_alert values('$longdate', '$hostname', '$servicename', $state_type, \'$extinfo\')";
			#print $sql.";\n";
			#print "$sql\n";
			$sth=$dbh->prepare($sql);
			if ( !defined $sth ) {
			   die "Cannot prepare statement: $DBI::errstr\n";
			   exit(1);
			}
			$sth->execute;		
			#print "SERVICE DOWNTIME\n";
			$sth->finish();
		}
	
		$search_pattern="HOST DOWNTIME ALERT";
		if ($desc=~/$search_pattern/) {
			($time_desc, $hostname, $type,@tmp_extinfo)=split(/[:;]+/, $line);
			$extinfo = "@tmp_extinfo";
			$search_pattern="\[\]";
			($part1, $part2)=split(/\[/,$time_desc);
			($timestamp, $part2)=split(/\]/,$part2);
			$timestamp=dealsWithApostrofe($timestamp);
			$hostname=dealsWithApostrofe($hostname);
			$type=dealsWithApostrofe($type);
			$extinfo=dealsWithApostrofe($extinfo);
	   	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($timestamp);
			$wday++;
			$yday++;
			$isdst++;
			$mon++;
			$year+=1900;
			$longdate="$year-$mon-$mday $hour:$min:$sec";
			# converts text to codes to speed up and save space 
			$state_type=1;
			if ($type eq "STARTED") {
				$state_type=0;
			}
			if ($type eq "STOPPED") {
				$state_type=1;
			}
			if ($type eq "CANCELLED") {
				$state_type=2;
			}
			$sql="insert into host_downtime_alert values('$longdate', '$hostname', $state_type, \'$extinfo\')";
			#print $sql.";\n";
			#print "$sql\n";
			$sth=$dbh->prepare($sql);
			if ( !defined $sth ) {
			   die "Cannot prepare statement: $DBI::errstr\n";
			   exit(1);
			}
			$sth->execute;
			#print "HOST DOWNTIME\n";
			$sth->finish();
			#exit(0);
		}
	
		$search_pattern="SERVICE ALERT";
		$search_pattern2="CURRENT SERVICE STATE";		
		$search_pattern3="INITIAL SERVICE STATE";		
		if ( ($desc=~/$search_pattern/) or ($desc=~/$search_pattern2/) or ($desc=~/$search_pattern3/)){
			($time_desc, $hostname, $servicename,$status,$hardsoft,$retry,@tmp_extinfo)=split(/[:;]+/, $line);
			$extinfo = "@tmp_extinfo";
			$search_pattern="\[\]";
			($part1, $part2)=split(/\[/,$time_desc);
			($timestamp, $part2)=split(/\]/,$part2);
			$timestamp=dealsWithApostrofe($timestamp);
			$hostname=dealsWithApostrofe($hostname);
			$servicename=dealsWithApostrofe($servicename);
			$status=dealsWithApostrofe($status);
			$hardsoft=dealsWithApostrofe($hardsoft);
			$retry=dealsWithApostrofe($retry);
			$extinfo=dealsWithApostrofe($extinfo);
			#print "$timestamp\n";
			#print "$hostname\n";
			#print "$servicename\n";
			#print "$status\n";
			#print "$hardsoft\n";
			#print "$retry\n";
			#print "$extinfo\n";
			#print "$line";
	   	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($timestamp);
			$wday++;
			$yday++;
			$isdst++;
			$mon++;
			$year+=1900;
			$longdate="$year-$mon-$mday $hour:$min:$sec";
			# converts text to codes to speed up and save space
			$status_int=0;
			if ($status eq "CRITICAL") {
				$status_int=2;
			}
			if ($status eq "WARNING") {
				$status_int=1;
			}
			if (($status eq "RECOVERY") || ($status eq "OK")) {
				$status_int=0;
			}
			if ($status eq "UNKNOWN") {
				$status_int=3;
			}

			$state_type=0;
			if ($hardsoft eq "SOFT") {
				$state_type=0;
			}
			if($hardsoft eq "HARD") {
				$state_type=1;
			}

			$sql="insert into service_alert values('$longdate', '$hostname', '$servicename', $status_int, $state_type, $retry, \'$extinfo\')";
			#print $sql.";\n";
			#print "$sql\n";
			$sth=$dbh->prepare($sql);
			if ( !defined $sth ) {
			   die "Cannot prepare statement: $DBI::errstr\n";
			   exit(1);
			}
			$sth->execute;
			$sth->finish();			
			#print "SERVICE ALERT\n";
			#exit(0);
		}
		#else {
		#	print "$line";
		#}	
		$search_pattern="HOST ALERT";
		$search_pattern2="CURRENT HOST STATE";
		$search_pattern3="INITIAL HOST STATE";
		if ( ($desc=~/$search_pattern/) or ($desc=~/$search_pattern2/) or ($desc=~/$search_pattern3/)) {
			($time_desc, $hostname, $status,$hardsoft,$retry,@tmp_extinfo)=split(/[:;]+/, $line);
			$extinfo = "@tmp_extinfo";
			$search_pattern="\[\]";
			($part1, $part2)=split(/\[/,$time_desc);
			($timestamp, $part2)=split(/\]/,$part2);
			$timestamp=dealsWithApostrofe($timestamp);
			$hostname=dealsWithApostrofe($hostname);
			$status=dealsWithApostrofe($status);
			$hardsoft=dealsWithApostrofe($hardsoft);
			$retry=dealsWithApostrofe($retry);
			$extinfo=dealsWithApostrofe($extinfo);
			#print "$timestamp\n";
			#print "$hostname\n";
			#print "$status\n";
			#print "$hardsoft\n";
			#print "$retry\n";
			#print "$extinfo\n";
			#print "$line";
	   	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($timestamp);
			$wday++;
			$yday++;
			$isdst++;
			$mon++;
			$year+=1900;
			$longdate="$year-$mon-$mday $hour:$min:$sec";
			# converts text to codes to speed up and save space
			$status_int=0;
			if($status eq "UNREACHABLE") {
				$status_int=2;
			}
			if ($status eq "DOWN") {
				$status_int=1;
			}
			if (($status eq "RECOVERY") || ($status eq "UP")) {
				$status_int=0;
			}

			$state_type=0;
			if ($hardsoft eq "SOFT") {
				$state_type=0;
			}
			if($hardsoft eq "HARD") {
				$state_type=1;
			}
			$sql="insert into host_alert values('$longdate', '$hostname', $status_int, $state_type, $retry, '$extinfo')";
			#print $sql.";\n";
			$sth=$dbh->prepare($sql);
			if ( !defined $sth ) {
			   die "Cannot prepare statement: $DBI::errstr\n";
			   exit(1);
			}
			$sth->execute;
			$sth->finish();
			#print "HOST ALERT\n";
			#exit(0);
		}	
		
		#print "$sql\n";
		#print "$line\n";
		#sleep(1);
		#exit(0);
	}
}

sub trim {
	local ($string)=@_;
	
	chomp($string);
	$string =~s/^\s+//;
	$string =~s/\s+$//;
	
	return($string);
}

sub dealsWithApostrofe {
	local ($string)=@_;
	
	$string=trim($string);
	$searchPattern="\'";
	if ($string=~/$searchPattern/) {
		@parts=split(/$searchPattern/, $string);
		$temp="";
		foreach $part (@parts) {
			$temp=$temp.$part;
		}
		$string=$temp;
	}
	return($string);
}
