#!/usr/bin/perl
#

use DBI;
use POSIX;

$VERSION="2.0";

$DBSERVER="localhost";
$DBNAME="opmon";
$DBUSER="root";
$DBPASS="oppass";

print "\nservice_change_name.pl Version $VERSION\n";

($hostname, $old_servicename, $new_servicename)=@ARGV;

if ($#ARGV<2) {
	print "\nUsage: service_change_name.pl <hostname> <old_servicename> <new_servicename>\n\n";
	exit(0);
}

print "\n\n";
print "Faca backup dos logs do opmon e pare o opmon antes rodar esse script\n";
print "\n\n";
print "Pressione <ENTER> para continuar\n";
print "\n\n";
$nada=<STDIN>;

$opmon_root_dir="/usr/local/opmon";
$opmon_logs_dir=$opmon_root_dir."/var/archives/";
$opmon_log_dir=$opmon_root_dir."/var/";

opendir(DIR, "$opmon_logs_dir");
@files=readdir(DIR);
close(DIR);

change_service_comments("/usr/local/opmon/var/comment.log", $hostname, $old_servicename, $new_servicename);
#change_service_name("/usr/local/opmon/var/archives/opmon-03-18-2004-00.log", $hostname, $old_servicename, $new_servicename);
exit(0);

$totalCount=0;
foreach $file (@files) {
	if ( ($file eq ".") or ($file eq "..") ) {
		next;
	}
	#print "$file\n";
	$temp=$opmon_logs_dir.$file;
	$hits=0;
	$hits=change_service_name($temp, $hostname, $old_servicename, $new_servicename);
	$totalCount=$totalCount+$hits;
}

# checks current opmon.log
$temp=$opmon_log_dir."opmon.log";
$hits=0;
$hits=change_service_name($temp, $hostname, $old_servicename, $new_servicename);
$totalCount=$totalCount+$hits;
print "\nTotal lines changed: $totalCount\n\n";

# Changes comment
$hits=0;
$hits=change_service_comments("/usr/local/opmon/var/comment.log", $hostname, $old_servicename, $new_servicename);
print "Total comments changed: $hits\n\n\n";

print "Updating database\n";

print "Connecting database opmon...";
$dbh = DBI->connect ( "dbi:mysql:dbname=$DBNAME;host=$DBSERVER", "$DBUSER", "$DBPASS");
if ( !defined $dbh ) {
        die "Cannot connect to database!\n";
}
print "done\n";

# service_alert
$sql="update service_alert set servicename='$new_servicename' where hostname='$hostname' and servicename='$old_servicename'";
print "$sql ...";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

# service_downtime_alert
$sql="update service_downtime_alert set servicename='$new_servicename' where hostname='$hostname' and servicename='$old_servicename'";
print "$sql ...";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

# acoes
$sql="update acoes set servicename='$new_servicename' where hostname='$hostname' and servicename='$old_servicename'";
print "$sql ...";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

$dbh->disconnect();

# perfparse
$dbh = DBI->connect ( "dbi:mysql:dbname=perfparse;host=$DBSERVER", "$DBUSER", "$DBPASS");
print "$sql ...";
if ( !defined $dbh ) {
        die "Cannot connect to database!\n";
}
print "done\n";

# perfdata_service_metric
#$hostname, $old_servicename, $new_servicename
$sql="delete from perfdata_service_metric where host_name='$hostname' and service_description='$old_servicename'";
print "$sql ...";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

# perfdata_service
$sql="delete from perfdata_service where host_name='$hostname' and service_description='$old_servicename'";
print "$sql ...";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

# remove "-" from hostname for perfdata table name compositon
$temp1=replaceCaracter("-","_",$hostname);

$table_name="perfdata_service_bin_".$temp1;

# perfdata_service_$new_table_name
$sql="update $table_name set service_description='$new_servicename' where host_name='$hostname' and service_description='$old_servicename'";
print "$sql ...";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish();
print "done\n";

$dbh->disconnect();

exit(0);

sub replaceCaracter {
	local ($oldCaracter, $newCaracter, $stringChange)=@_;

	local $newstring="";
	@parts=split(//,$stringChange);
	foreach $caracter (@parts) {
		if ($oldCaracter eq $caracter) {
			$newstring=$newstring.$newCaracter;
		}
		else {
			$newstring=$newstring.$caracter;
		}
	}
	return($newstring);
}

sub change_service_comments {
	local ($filename, $hostname, $old_servicename, $new_servicename)=@_;

	open(FILE, $filename);
	@lines=<FILE>;
	close(FILE);
	
	print "File lines: $#lines\n";

	$new_file="/tmp/opmon-comment.log";
	open(NEWFILE,">$new_file");
	$search_pattern1="servicecomment";
	$search_pattern2="{";
	$search_pattern3="}";
	$count=0;
	for ($i = 0; $i <= $#lines; ++$i) {
		if ( ($lines[$i]=~/$search_pattern1/) and ($lines[$i]=~/$search_pattern2/) ) {
			print NEWFILE $lines[$i];
			$found=0;
			while ( ($found==0) and ($i<=$#lines) ) {
				$i++;
				if ($lines[$i]=~/$search_pattern3/) {
					$found=1;
				}
				else {
					$search_host="host_name=";
					if ($lines[$i]=~/$search_host/) {
						print NEWFILE $lines[$i];
						($id,$host_temp)=split(/=+/,$lines[$i]);
						chomp($host_temp);
						if ($host_temp eq $hostname) {
							$i++;
							($id,$service_temp)=split(/=+/,$lines[$i]);
							chomp($service_temp);
							if ($service_temp eq  $old_servicename) {
								$new_line=$id."=".$new_servicename."\n";;
								print NEWFILE $new_line;
								print $new_line;
								$count++;
							}
							else {
								print NEWFILE $lines[$i];
							}
						}
					}
					else {
						print NEWFILE $lines[$i];
					}
				}
			}
			print NEWFILE $lines[$i];
		}
		else {
			print NEWFILE $lines[$i];
		}
	}
	close(NEWFILE);
	print "File lines: $#lines  -  $i\n";	
	if ($count>0) {
		#$temp="/bin/cp -f $new_file $filename";
		#system($temp);
		#$temp="/bin/sync";
		#system($temp);
	}
	#unlink($new_file);
	print "$filename - $count hits\n";
	return($count);	
}

sub change_service_name {
	local ($filename, $hostname, $old_servicename, $new_servicename)=@_;
	open(FILE, $filename);
	@lines=<FILE>;
	close(FILE);
	
	$new_file="/tmp/opmon-host_change_name.log";
	open(NEWFILE,">$new_file");
	$count=0;
	foreach $line (@lines) {
		chop($line);
		$search_pattern1="SERVICE ALERT";
		$search_pattern2="INITIAL SERVICE STATE";
		$search_pattern3="CURRENT SERVICE STATE";
		$search_pattern4="SERVICE FLAPPING ALERT";
		$search_pattern5="SERVICE NOTIFICATION";
		$search_pattern6="EXTERNAL COMMAND";
		if ( ($line=~/$search_pattern1/) or ($line=~/$search_pattern2/) or 
		     ($line=~/$search_pattern3/) or ($line=~/$search_pattern4/) or
		     ($line=~/$search_pattern5/) or ($line=~/$search_pattern6/) ) {
			@parts=split(/[:;]/, $line);
			$indexHostname=1;
			if ( ($parts[0]=~$search_pattern1) or ($parts[0]=~$search_pattern2) or 
			     ($parts[0]=~$search_pattern3) or ($parts[0]=~$search_pattern4) ) {
				$indexHostname=1;
				$indexServicename=2;
			}
			elsif ( ($parts[0]=~$search_pattern5) or ($parts[0]=~/$search_pattern6/) ) {
				$indexHostname=2;
				$indexServicename=3;
			}
			# if split found more then 2 parts and the second is our hostname
			$tempHostname=trimSpaces($parts[$indexHostname]);
			$tempServicename=trimSpaces($parts[$indexServicename]);
			if ( ($#parts >1 ) and ($tempHostname eq $hostname) and ($tempServicename eq $old_servicename)) {
				#print "$parts[0] $parts[1] $parts[2] $parts[3]\n";
				$new_line="";
				for ($i = 0; $i <= $#parts; ++$i) {
					if ( $i==0 ) {
						$new_line=$parts[$i].":";
					}
					elsif ( $i==$indexHostname ) {
						if ($indexHostname==1) { # this pattern has a space after hostname
							$new_line=$new_line." ".$hostname.";";
						}
						elsif ($indexHostname==2) { # this pattern has no space after hostname
							$new_line=$new_line.$hostname.";";
						}
					}
					elsif ( $i==$indexServicename ) {
						$new_line=$new_line.$new_servicename.";";
					}					
					else {
						if ($i==$#parts) { # last part of line doest have ";" at the end
							$new_line=$new_line.$parts[$i];
						}
						else {
							$new_line=$new_line.$parts[$i].";";
						}
					}
				}
				print NEWFILE $new_line."\n";;
				$count++;
			}
			else {
				print NEWFILE $line."\n";
			}
		}
		else {
			print NEWFILE $line."\n";
		}
	}
	close(NEWFILE);
	if ($count>0) {
		$temp="/bin/cp -f $new_file $filename";
		system($temp);
		$temp="/bin/sync";
		system($temp);
	}
	unlink($new_file);
	print "$filename - $count hits\n";
	#print $new_file."\n";
	return($count);
}

sub trimSpaces {
	local ($string)=@_;
	
	$string =~s/^\s+//;
	$string =~s/\s+$//;
	
	return($string);
}

# Hostname index is 1
#[1041216498] HOST ALERT: giozza-virtua-fln-01;UP;SOFT;3;PING OK - Packet loss =0%, RTA = 25.84 ms
#[1041216498] SERVICE ALERT: giozza-virtua-fln-01;Opinfo Client;CRITICAL;SOFT;1;C
#[1044051935] HOST FLAPPING ALERT: cisco-restinga-pae-01;STOPPED; Host appears to have stopped flapping (0.0% change < 5.0% threshold)
#[1075529271] SERVICE FLAPPING ALERT: tokstok-diveo-spo-01;Load;STARTED; Service appears to have started flapping (23.3% change > 20.0% threshold)
# Hostname index is 2
#[1101423923] HOST NOTIFICATION: adamo.romeira;dalkia-brascan-speedy-spo;DOWN;host-notify-by-email;Socket timeout after 10 seconds
#[1074285047] SERVICE NOTIFICATION: alessandro;sabemi-diveo-pae-01;VPN-RJO;CRITICAL;notify-by-email;CRITICAL - 10 enviados, 0 recebidos,100% pacotes perdidos

#[1113140714] EXTERNAL COMMAND: ADD_SVC_COMMENT;dbserver;Disco D;1;Chander;Seguindo procedimentos operacionais...... responsveis sero informados no prximo dia til
#[1113219451] EXTERNAL COMMAND: ADD_SVC_COMMENT;dbserver;Disco D;1;Chander;Cfe contato c/ o Andre o mesmo ir verificar o problema a tarde
#[1084350419] EXTERNAL COMMAND: ADD_SVC_COMMENT;dbserver;Disco D;1;Giovani - CPD;ACKNOWLEDGEMENT: Responsaveis a par do assunto.
#[1084350419] EXTERNAL COMMAND: ACKNOWLEDGE_SVC_PROBLEM;dbserver;Disco D;1;Responsaveis a par do assunto.
#[1133270295] EXTERNAL COMMAND: SCHEDULE_FORCED_SVC_CHECK;dbserver;Disco D;1133270293
