#!/usr/bin/php
<?php
include "/usr/local/opmon/etc/config.php";

if ($argc > 1 ) {
	if ($argc==6) {
		$ret_stat=migrate_data_stats($argv[1],$argv[2],$argv[3],$argv[4],$argv[5]);
		if ($ret_stat===false) {
			print " could not find metrid_id\n";
		}
		else {
			print " $ret_stat records migrated\n";
		}
	}
	else {
		print "You can import Nisca data manually,just pass the parameters\n\n";
		print "php ./$argv[0] <host_id> <service_id> <host_name> <if_id> <ifname>\n\n";
		print "host_id    - from opcfg\n";
		print "service_id - from opcfg\n";
		print "host_name  - from stats DB stats_ifs table\n";
		print "If_id      - in stats_ifs from stats DB stats_ifs table\n";
		print "ifame      - in stats_ifs from stats DB stats_ifs table\n\n";
	}
	exit(0);
}

$sql="SELECT id,hostname,if_name from stats.stats_ifs;";
$ret=do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
while(!$ret->EOF) {
	$ret_array=op_find_host_service($ret->fields->hostname, $ret->fields->if_name);
	if ($nr_rows===false)
		$nr_rows=0;
	else
		$nr_rows=$ret_array[0];
	if ($nr_rows==0) {
		print "{$ret->fields->hostname}\t{$ret->fields->if_name}\tno match\n";
	}
	else if ($nr_rows>1) {
		print "{$ret->fields->hostname}\t{$ret->fields->if_name}\ttoo many matches $nr_rows\n";
	}
	else if ($nr_rows==1) {
		$nr_rows=$ret_array[0];
		$host_id=$ret_array[1];
		$service_id=$ret_array[2];
		print "{$ret->fields->hostname}/$host_id - {$ret->fields->if_name}/$service_id migrating... ";
		$ret_stat=migrate_data_stats($host_id,$service_id,$ret->fields->hostname,$ret->fields->id,$ret->fields->if_name);
		if ($ret_stat===false) {
			print " could not find metrid_id\n";
		}
		else {
			print " $ret_stat records migrated\n";
		}
	}
	$ret->MoveNext();
}
$ret->Close();

print "\nDatabase migration done\n";
exit(0);

/* copy data from stats to service_perf_xx */
function migrate_data_stats($host_id,$service_id,$host_name_stats,$if_id_stats,$ifname)
{
	$metric_id_down=op_get_metric_id($host_id,$service_id,"Download");
	$metric_id_indisc=op_get_metric_id($host_id,$service_id,"InDiscards");
	$metric_id_inerrors=op_get_metric_id($host_id,$service_id,"InErrors");
	$metric_id_up=op_get_metric_id($host_id,$service_id,"Upload");
	$metric_id_outdisc=op_get_metric_id($host_id,$service_id,"OutDiscards");
	$metric_id_outerrors=op_get_metric_id($host_id,$service_id,"OutErrors");
	if (($metric_id_up===false) || ($metric_id_down==false) ) {
		return(false);
	}
	
	$sql="SELECT speed FROM stats.interfaces where hostname='$host_name_stats' and if_name='$ifname';";
	$ret = do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
	$ifspeed=0;
	while(!$ret->EOF) {
		$ifspeed=$ret->fields->speed;
		$ret->MoveNext();
	}
	$ret->Close();
	if ($ifspeed>0) {
		/* Convert fo kbps */
		$ifspeed=round($ifspeed/10,0);
	}
	
	$new_tablename=stats_table_name($host_name_stats);
	$sql="SELECT ctime,stamp,r_bytes,r_errors,r_dropped,t_bytes,t_errors,t_dropped from stats.$new_tablename where if_id='$if_id_stats' order by ctime asc;";
	$last_data=false;
	$last_r_bytes=0;
	$last_t_bytes=0;
	$last_timestamp=0;
	$count=0;
	$ret = do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
	while(!$ret->EOF) {
		$row = $ret->fields;
		if ($last_data===false) {
			$last_data=true;
			$last_r_bytes=$row->r_bytes;
			$last_t_bytes=$row->t_bytes;
			$last_timestamp=$row->stamp;
		}
		else {
			$elpased_time=$row->stamp - $last_timestamp;
			if ($elpased_time<1) {
				$last_data=false;
				continue;
			}
			$download=round(($row->r_bytes - $last_r_bytes)/$elpased_time*8/1000,2);
			$upload=round(($row->t_bytes - $last_t_bytes)/$elpased_time*8/1000,2);
			if ( ($download<0) || ($upload<0) ) {
				$last_data=false;
				continue;
			}
			if ( ($download>$ifspeed) || ($upload>$ifspeed) ) {
				$last_data=false;
				continue;
			}
			$sql_insert="INSERT IGNORE INTO service_perf_$host_id values ('{$row->ctime}','$service_id','$metric_id_down','$download','0','0')";
			do_query($sql_insert,DBPERF,OPDB_FETCH_OBJ);
			$sql_insert="INSERT IGNORE INTO service_perf_$host_id values ('{$row->ctime}','$service_id','$metric_id_up','$upload','0','0')";
			do_query($sql_insert,DBPERF,OPDB_FETCH_OBJ);
			
			if ($metric_id_indisc) {
				$sql_insert="INSERT IGNORE INTO service_perf_$host_id values ('{$row->ctime}','$service_id','$metric_id_indisc','{$row->r_dropped}','0','0')";
				do_query($sql_insert,DBPERF,OPDB_FETCH_OBJ);
			}
			if ($metric_id_inerrors) {
				$sql_insert="INSERT IGNORE INTO service_perf_$host_id values ('{$row->ctime}','$service_id','$metric_id_inerrors','{$row->r_errors}','0','0')";
				do_query($sql_insert,DBPERF,OPDB_FETCH_OBJ);
			}
			if ($metric_id_outdisc) {
				$sql_insert="INSERT IGNORE INTO service_perf_$host_id values ('{$row->ctime}','$service_id','$metric_id_outdisc','{$row->t_dropped}','0','0')";
				do_query($sql_insert,DBPERF,OPDB_FETCH_OBJ);
			}
			if ($metric_id_outerrors) {
				$sql_insert="INSERT IGNORE INTO service_perf_$host_id values ('{$row->ctime}','$service_id','$metric_id_outerrors','{$row->t_errors}','0','0')";
				do_query($sql_insert,DBPERF,OPDB_FETCH_OBJ);
			}
			$count++;
			$last_r_bytes=$row->r_bytes;
			$last_t_bytes=$row->t_bytes;
			$last_timestamp=$row->stamp;
		}
		$ret->MoveNext();
	}
	$ret->Close();
	return($count);
}

/* generate stats table name */
function stats_table_name($host_name)
{
	$new_tablename="stats_";
	for ($j=0;$j<strlen($host_name);$j++) {
		if ( (substr($host_name, $j, 1)=="-") or (substr($host_name, $j, 1)==".") ) {
	  	$new_tablename=$new_tablename."_";
		}
	  else {
			$new_tablename=$new_tablename.substr($host_name, $j, 1);
		}
	}
	return($new_tablename);
}

function op_get_metric_id($host_id,$service_id,$metric)
{
	$sql="SELECT metric_id from opcfg.service_metric where host_id='$host_id' and service_id='$service_id' and metric='$metric';";
	$ret = do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
	$rows=$ret->RecordCount();
	if ($rows==0) {
		$metric_id=false;
	}
	else {
		$metric_id=$ret->fields->metric_id;
	}
	$ret->Close();
	return($metric_id);
}

function op_find_host_service($host_name, $if_name)
{
 	$host_id=get_host_id_by_name($host_name);
 	if ($host_id===false)
 		return (false);
 	$ret_array=array();
 	/* try snmp_method_ifname */
	$sql = "select * from opcfg.opmon_rtg where host_id=$host_id and snmp_method_ifname like '%$if_name%';";
	$ret = do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
	$rows=$ret->RecordCount();
	if ($rows>0) {
		$ret_array[]=$rows;
		$ret_array[]=$host_id;
		$ret_array[]=$ret->fields->service_id;
		$ret->Close();
		return($ret_array);
	}
	$ret->Close();
		
 	/* try ifname */
	$sql = "select * from opcfg.opmon_rtg where host_id=$host_id and ifname like '%$if_name%';";
	$ret = do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
	$rows=$ret->RecordCount();
	if ($rows>0) {
		$ret_array[]=$rows;
		$ret_array[]=$host_id;
		$ret_array[]=$ret->fields->service_id;
		$ret->Close();
		return($ret_array);
	}
	$ret->Close();
		
 	/* try ifdescr */
	$sql = "select * from opcfg.opmon_rtg where host_id=$host_id and ifdescr like '%$if_name%';";
	$ret = do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
	$rows=$ret->RecordCount();
	$ret_array[]=$rows;
	$ret_array[]=$host_id;
	$ret_array[]=$ret->fields->service_id;
	$ret->Close();
	return($ret_array);
}

function get_tables($dbname)
{
	mysql_select_db($dbname);
	$sql = "show tables;";
	$tb_array=array();
	$ret = mysql_query($sql);
	while ($row = mysql_fetch_row($ret)) {
		$tb_array[]=$row[0];
	}
	mysql_free_result($ret);
	return($tb_array);
}

function get_databases()
{
	$sql = "show databases;";
	$db_array=array();
	$ret = do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
	while(!$ret->EOF) {
		$row = $ret->fields;
		$db_array[]=$row->Database;
		$ret->MoveNext();
	}
	$ret->Close();
	return($db_array);
}

function convert_tables_to_utf($tables)
{	
	foreach($tables as $db => $a_tables) {
	
		foreach($a_tables as $tb) {
		
			print "Working on table $tb:\n";
	
			$q = "desc $tb";
			$ret = do_query($q,$db,OPDB_FETCH_OBJ);
			$update_fields = array();
			$compare_fields = array();
			while(!$ret->EOF) {
	
				if (strstr($ret->fields->Type,"varchar") !== false || 
				    strstr($ret->fields->Type,"text") !== false) {
	
					$update_fields[] = $ret->fields->Field;
	
				} else {
					$compare_fields[] = $ret->fields->Field;
				}
	
				$ret->MoveNext();
			}
			$ret->Close();
	
			if (!empty($update_fields)) {
	
				print "\tWe need to convert these table fields:\n";
				foreach($update_fields as $f) {
					print "\t\t$f\n";
				}
				print "\tConverting:     ";
	
				$q = "select * ".
				     "from $tb";
	
				$ret = do_query($q,$db,OPDB_FETCH_OBJ);
				$c = 0;
				$problems = 0;
				while(!$ret->EOF) {
	
					give_feedback($c);
	
					$bypass = true;
					foreach($update_fields as $f) {
	
						$aux = json_encode($ret->fields->$f);
						$ret->fields->$f = addslashes(utf8_encode($ret->fields->$f));
						if ($aux == false || $aux == "null")
							$bypass = false;
					}

					if (!$bypass) {
	
						$problems++;
	
						$aux = array();
						foreach($update_fields as $f) {
							$aux[] = "$f = '{$ret->fields->$f}' ";
						}
	
						$q = "update $tb ".
						     "set ".implode(",",$aux)." ".
						     "where ";

						$aux = array();
						foreach($compare_fields as $f) {
							if ($ret->fields->$f == null) {
								$aux[] = "isnull($f)";
							} else {
								$aux[] = "$f = '".addslashes($ret->fields->$f)."'";
							}
						}

						$q .= implode(" and ",$aux);

						// RUN  UPDATE QUERY!
						$ret2 = do_query($q,$db,OPDB_FETCH_OBJ);
						$ret2->Close();
	
					}
	
	
					$c++;
					if ($c > 3) {
						$c = 0;
					}
	
					$ret->MoveNext();
				}
				$ret->Close();
	
				print "\n\t$problems rows updated\n";
	
			} else {
				print "\tdoesn't need convertion\n";
			}
	
	
			print "\n";
		}
	
	}
}

function give_feedback($count) {

	print chr(8).chr(8).chr(8);
	switch($count) {

	case 0:
		print "[|]";
		break;

	case 1:
		print "[/]";
		break;

	case 2:
		print "[-]";
		break;

	case 3:
		print "[\\]";
		break;
	}
}

function log_table_problems($dbname, $tb_name,$errno,$err_string)
{
	$handle = fopen("tables-problems.log", "a+");
	$logMsg=$dbname." - ".$tb_name." - ".$errno." - ".$err_string."\n";
	fputs($handle, $logMsg);
	fclose($handle);
}

?>

