#!/usr/bin/php
<?php
ini_set("memory_limit","512M");
ini_set("max_execution_time","103600");
require_once("/usr/local/opmon/etc/config.php");

// get system-discovery-snmp-interface command_id
$query = "select command_name, command_id from opcfg.nagios_commands where command_name = 'system-discovery-snmp-interface'";
$result = do_query($query,DBOPCFG,OPDB_FETCH_OBJ);
if ($result->RecordCount() > 0) {
	$obj=$result->fields;
	$command_id = $obj->command_id;
}
else {
	print "Could  no find ID for command system-discovery-snmp-interface\n";
	exit(0);
}
$result->Close();

print "=> system-discovery-snmp-interface command_id $command_id\n";

// gets all hosts and services that use the command
$hosts = array();
$count_svc = 0;
$query = "select host_id, service_id from nagios_services where check_command='$command_id'";
$result = do_query($query,DBOPCFG,OPDB_FETCH_OBJ);
if ($result->RecordCount() > 0) {
	while( !$result->EOF ) {
		$host_id =  $result->fields->host_id;
		if ($host_id == null || empty($host_id)) {
			$result->MoveNext();
			next;
		}
		$service_id = $result->fields->service_id;
      $hosts[$host_id][] = $service_id;
      $count_svc++;
      $result->MoveNext();
	}
}
else {
	print "No services found using command_id $command_id\n";
	exit(0);
}
$result->Close();
print "=> $count_svc services use the command system-discovery-snmp-interface\n\n";

$hosts_ifspeed = array();
// get ifSpeed set on plugin
foreach ($hosts as $host_id => $services) {
	foreach ($services as $service_id) {
		$query = "select * from nagios_services_check_command_parameters where service_id = '$service_id';";
		$result = do_query($query,DBOPCFG,OPDB_FETCH_OBJ);
		if ($result->RecordCount() > 3) {
			$result->MoveNext();
			$result->MoveNext();
			/* the third parameter for the plugin is ifspeed */
			$ifspeed = $result->fields->parameter;
			$svc_ifspeed = array();
			$svc_ifspeed['service_id'] = $service_id;
			$svc_ifspeed['ifspeed'] = $ifspeed;
			$hosts_ifspeed[$host_id][] = $svc_ifspeed;
			unset($svc_ifspeed);
		}
		$result->Close();
	}
}	

$count_dels = 0;
foreach ($hosts_ifspeed as $host_id => $svcs) {
	foreach ($svcs as $svc) {
		if (!empty($svc['ifspeed']) and $svc['ifspeed'] > 0) {
			/* get host_name and service_description */
			$host_name = $service_description = "not defined";
			$query = "SELECT host_name, service_description FROM opmon4.service_status where host_id='{$host_id}' and service_id = '{$svc['service_id']}'";
			$result = do_query($query,DBOPMON,OPDB_FETCH_OBJ);
			if ($result->RecordCount() > 0) {
				$host_name = $result->fields->host_name;
				$service_description = $result->fields->service_description;
			}
			$result->Close();

			$del_ifspeed = $svc['ifspeed'] * 1.5;
			$query = "DELETE FROM opperf.service_perf_{$host_id} WHERE service_id = '{$svc['service_id']}' AND perf_value > $del_ifspeed";
			$count_dels++;
			print "$count_dels / $count_svc - $host_name - $service_description\n";
			print "$query ";
			do_query($query,DBPERF,OPDB_FETCH_OBJ);
			print "OK\n";
		}
	}
}		

print "\nCleaning wrong snmp interface utilization done\n";

exit(0);
