#!/usr/bin/php
<?php
ini_set("memory_limit","512M");
ini_set("max_execution_time","103600");
require_once("/usr/local/opmon/etc/config.php");

$log_file = "/var/log/opmon-summarizer.log";
print "Logging to $log_file\n";
unlink($log_file);

write_log("Starting OpMon summarizer");

//days  limite para summarizao e para cada array criado ser incremendato a data start para a proxima execuo
//15 dias as is
//60 dias 30 minutos
//180 dias 120 minutos
//360 dias 1440 minutos
//
// means            none          30            120          1440
//            |=============|=============|=============|=============|
// days       0             15            75           255           615
// intervals         15           60            180           360
//

//$summarizer_array = array (
// array("days" => 15, "mean" => 0, "data_start" => "","data_end" => "", "timestamp_start" => "", "timestamp_end" => ""),
// dados com idade de 0 a 15 dias no sumariza
// array("days" => 60, "mean" => 30, "data_start" => "","data_end" => "", "timestamp_start" => "", "timestamp_end" => ""),
// dados com idade de 15 a 75(15 + 60) dias sumariza em 30 minutos
// array("days" => 180, "mean" => 120, "data_start" => "","data_end" => "", "timestamp_start" => "", "timestamp_end" => ""),
// dados com idade de 75(15+60) at 255(75+180) sumariza em 120 minutos
// array("days" => 360, "mean" => 1440, "data_start" => "","data_end" => "", "timestamp_start" => "", "timestamp_end" => "")
// dados com idade de 255 at 615(255+360) sumariza em 1440 minutos
//);

/*
Para sumarizar tudo que tenha mais de um ano em 60 min:
$summarizer_array = array (
 array("days" => 365, "mean" => 0, "data_start" => "","data_end" => "", "timestamp_start" => "", "timestamp_end" => ""),
//Supondo que este cliente tenha 3 anos de dados
 array("days" => 1095, "mean" => 60, "data_start" => "","data_end" => "", "timestamp_start" => "", "timestamp_end" => ""),
);
*/

/* get all services that have metrics */
$sql="SELECT _summarization_enable,_summarization_realdata,_summarization_hourly, _remaining_data FROM nagios_main;";
$result = do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
$parameters = false;
if( !$result->EOF ) {
	$parameters = $result->fields;
}
$result->Close();

if ($parameters->_summarization_enable == 0) {
	write_log("Summarizer disabled on OpCfg");
	exit(0);
}

//30 dias as is
//60 dias 60 minutos
//180 dias 120 minutos
//360 dias 1440 minutos
$summarizer_array = array (
	array("days" => $parameters->_summarization_realdata, "mean" => 0, "data_start" => "","data_end" => "", "timestamp_start" => "", "timestamp_end" => ""),
	array("days" => $parameters->_summarization_hourly, "mean" => 60, "data_start" => "","data_end" => "", "timestamp_start" => "", "timestamp_end" => ""),
	array("days" => 30, "mean" => $parameters->_remaining_data, "data_start" => "","data_end" => "", "timestamp_start" => "", "timestamp_end" => "")
);

write_log("Summarizer dates");

/* Calculate dates to summarizer */
$days_from_now=0;
$days_from_last=0;
$i=0;
$begin_days = 0;
$initial = new DateTime('NOW');
$init_date = $initial->format('Y-m-d');
foreach ($summarizer_array as $summarizer_item) {

	/* Calculate the day going bac to summarize*/
	$end_days = $begin_days;
	$begin_days = $end_days + $summarizer_item['days'];

	if ($i == 0) {
		$d_end = new DateTime($init_date." 23:59:59");
	}
	else {
		$d_end = new DateTime($init_date." 00:00:00");
	}
	$d_begin = new DateTime($init_date." 00:00:00");
	$interval_end = new DateInterval('P'.$end_days.'D');
	$interval_begin = new DateInterval('P'.$begin_days.'D');
	$d_end->sub($interval_end);
	$d_begin->sub($interval_begin);

	$summarizer_array[$i]["date_start"]=$d_begin->format('Y-m-d H:i:s');
	$summarizer_array[$i]["date_end"]=$d_end->format('Y-m-d H:i:s');
	$summarizer_array[$i]["timestamp_start"]=$d_begin->getTimestamp();
	$summarizer_array[$i]["timestamp_end"]=$d_end->getTimestamp();
	if ($i==0 && $summarizer_array[$i]["mean"]>0) {
		write_log("First summarize mean option must be 0");
		write_log("\tThis is the period where data will not be modified");
		exit(0);
	}

	if ($summarizer_array[$i]["mean"] == 0) {
		write_log("From ".$summarizer_array[$i]["date_start"]." to ".$summarizer_array[$i]["date_end"]. " no summarization");
	}
	else {
		$summarization_time = $summarizer_array[$i]["mean"]/60;
		write_log("From ".$summarizer_array[$i]["date_start"]." to ".$summarizer_array[$i]["date_end"]. " per ".$summarization_time."h");
	}
	$i++;
}

/* get all services that have metrics */
$sql="SELECT a.host_id, a.service_id, a.metric_id, a.metric, b.host_name, b.service_description FROM opcfg.service_metric as a, opmon4.service_status as b WHERE a.host_id=b.host_id AND a.service_id=b.service_id;";
$result = do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
$metrics=array();
while( !$result->EOF ) {
	$metrics[]=$result->fields;
	$result->MoveNext();
}
$result->Close();

/* Walk metrics and summarize */
$total_rows = 0;
$total_summarized = 0;
$total_size_before_summarizer = 0;
$total_size_after_summarizer = 0;
$metric_counter = 0;
$host_array = array();
foreach ($metrics as $metric) {
	/* Keep host_ids summarized for future optimization */
	if (array_search($metric->host_id, $host_array) === false) {
		$total_size_before_summarizer+= check_table_size("service_perf_".$metric->host_id, "opperf")."\n";
		array_push($host_array, $metric->host_id);
	}
	$metric_counter++;
	write_log("-------------------------------------------------------");
	write_log("Summarizing metric ".$metric_counter." / ".count($metrics)." - ".$metric->host_name." - ".$metric->service_description." - ".$metric->metric);
	foreach ($summarizer_array as $summarizer_item) {
		if ($summarizer_item['mean']==0) // do not summarize this time
			continue;
		summarize_metric($metric, $summarizer_item);
	}
}
write_log("-------------------------------------------------------");
/* Optimize tables summarized and get total new space used */
/* write_log("Optimizing Tables");
asort($host_array);
$host_counter = 0;
foreach ($host_array as $host_id) {	
	$host_counter++;
	$sql = "OPTIMIZE TABLE service_perf_".$host_id.";";
	write_log("Host ".$host_counter." / ".count($host_array)." - ".$sql);
	do_query($sql,"opperf");
	$total_size_after_summarizer+= check_table_size("service_perf_".$host_id, "opperf")."\n";
} */
$msg = "Finished summarizing\n";
$msg .= "Total Rows:\n";
$msg .= "\n\tRows processed: $total_rows";
$msg .= "\n\tRows left: $total_summarized";
$msg .= "\n\tRow removed ".round($total_rows-$total_summarized,0);
/* $msg .= "\n\nTotal Sizes:";
$msg .= "\n\tBefore: ".round($total_size_before_summarizer,2)."MB";
$msg .= "\n\tAfter ".round($total_size_after_summarizer,2)."MB";
$msg .= "\n\tSpace saved  ".round($total_size_before_summarizer-$total_size_after_summarizer, 2)."MB\n";
*/
$msg .= "\nThank you for using OpMon Technologies\n";
write_log($msg);
exit(0);

function summarize_metric($metric, $summarizer_item) {
	global $total_rows;
	global $total_summarized;

	/* Check if table exists, service might have metrics but have not retured any performance data_end */
	/* Server change but new server is missing the plugin */
	$table_name="service_perf_".$metric->host_id;
	$tables_exists=check_table_exists($table_name, DBPERF);
	if ($tables_exists===FALSE)
		return;
	write_log("Date: {$summarizer_item['date_start']}  {$summarizer_item['date_end']} Mean {$summarizer_item['mean']}...");

	$rows_processed = 0;
	$rows_inserted = 0;

	for ($timestamp = $summarizer_item["timestamp_start"];$timestamp<$summarizer_item["timestamp_end"];$timestamp+=$summarizer_item["mean"]*60) {
		$timestamp_end = $timestamp + $summarizer_item["mean"]*60;
		/* Build dates for select and delete */
		$date_start=date('Y-m-d H:i:s', $timestamp);
		$date_end=date('Y-m-d H:i:s', $timestamp_end);
		$sel_query = "SELECT avg(perf_value) as perf_value, avg(warning) as warning, avg(critical) as critical, avg(baseline) as baseline, avg(lower_limit) as lower_limit, avg(upper_limit) as upper_limit, count(*) as entries from service_perf_".$metric->host_id." WHERE ";
			$sel_query .= "entry_time>='$date_start' AND entry_time<'$date_end' AND ";
			$sel_query .= "service_id='".$metric->service_id."' AND metric_id='".$metric->metric_id."';";
		$del_query = "DELETE from service_perf_".$metric->host_id." WHERE ";
			$del_query .= "service_id='".$metric->service_id."' AND metric_id='".$metric->metric_id."' AND ";
			$del_query .= "entry_time>='$date_start' AND entry_time<'$date_end';";

		$result = do_query($sel_query,DBPERF,OPDB_FETCH_OBJ);
		$found_records=$result->RecordCount();
		if ($found_records > 0) {
			$obj=$result->fields;
			if ($obj->entries > 1) {
				$rows_processed += $obj->entries;
				$rows_inserted ++;
				/* Create the insert for the new summarized data */
				$insert_query="INSERT IGNORE INTO service_perf_".$metric->host_id." ";
				$insert_query.="(entry_time, service_id, metric_id, perf_value, warning, critical, baseline, lower_limit, upper_limit) ";
				$insert_query.="values ('$date_start','{$metric->service_id}','{$metric->metric_id}','{$obj->perf_value}','{$obj->warning}', '{$obj->critical}',". (empty($obj->baseline) ? "NULL" : "'{$obj->baseline}'").",". (empty($obj->lower_limit) ? "NULL" : "'{$obj->lower_limit}'").",".(empty($obj->upper_limit) ? "NULL" : "'{$obj->upper_limit}'").");";
				/* Run delete and insert queries */
				do_query($del_query,DBPERF);
				do_query($insert_query,DBPERF);
			}
		}
		$result->Close();
	}
	write_log("\trows $rows_processed / inserted $rows_inserted  / removed ".($rows_processed - $rows_inserted));
	$total_rows+= $rows_processed;
	$total_summarized+= $rows_inserted;
}

function check_table_exists($table_name, $dbname)
{
	$query="show tables;";
	$result = do_query($query,$dbname);

	$tables = array();
	while( !$result->EOF ) {
		$tables[]=array_shift($result->fields);
		$result->MoveNext();
	}
	$result->Close();
	$found=array_search($table_name, $tables);
	return($found);
}

/* returns the size of the table in MB */
function check_table_size($table_name, $dbname)
{
	$ret = 0;
	$tables_exists=check_table_exists($table_name, $dbname);
	if ($tables_exists===FALSE)
		return $ret;

	$query="SELECT round(((data_length + index_length) / 1024 / 1024), 2) as size  FROM information_schema.TABLES  WHERE table_schema = '$dbname' and table_name = '$table_name';";
	$result = do_query($query,$dbname,OPDB_FETCH_OBJ);
	if ($result->RecordCount() > 0) {
		$obj=$result->fields;
		$ret = $obj->size;
	}
	return($ret);
}

function write_log($msg) {
	global $log_file;

	$initial = new DateTime('NOW');
	$date_log=$initial->format('Y-m-d H:i:s');
	unset($initial);
	$FILE = fopen($log_file, "a+");
	if ($FILE !== false) {
		fputs($FILE, $date_log." - ".$msg."\n");
		flush($FILE);
		fclose($FILE);
	}
}

?>
