#!/usr/bin/php
<?php

include "/usr/local/opmon/etc/config.php";

function usage() {
	print "Usage:\n";
	print "\t./svccommand.php <host name> <service description>\n";
	exit;
}

function main($argv) {

	set_logged_user("opmonadmin");
	$host_name = $argv[1];
	$service_description = $argv[2];

	if (empty($host_name))
		usage();
	
	$host = get_host_by_name($host_name);
	if (get_class($host) != "Host") {
		print "Unable to find host $host_name.\n";
		exit;
	}

	if (empty($service_description)) {
		$command_line = $host->get_command_line();
		print "$command_line\n";
		exit;
	}

	$services = $host->get_services();
	$found = false;
	foreach($services as $svc) {
		if ($svc->get_service_description() == $service_description) {
			$found = true;
			$command_line = $svc->get_command_line();
			break;
		}
	}

	if (!$found) {
		print "Unable to find service $service_description on host $host_name\n";
		exit;
	}

	print "$command_line\n";

}

main($argv);

?>
