#!/usr/bin/php
<?php

include "/usr/local/opmon/etc/config.php";

/* Tables that will go through field utf8_encode convertion */
$tables = array(
                'opmon4' => array('service_comment', 'host_comment', 'opdocs_list', 'scats', 'service_state_change', 'host_state_change'),
                'opcfg' => array('service_metric')
);

$db_array=array();
$db_array=get_databases();
foreach ($db_array as $dbname) {
	if ( ($dbname=="information_schema") || ($dbname=="mysql") || ($dbname=="perfparse") || ($dbname=="opmon") || ($dbname=="stats") ) continue;
	$sql="ALTER DATABASE `$dbname` CHARACTER SET utf8;";
	print "$sql ";
	do_query($sql, DBOPCFG);
	print "  done.\n";
	$tb_array=array();
	$tb_array=get_tables($dbname);
	foreach ($tb_array as $tb_name) {
		$sql="SELECT ENGINE, TABLE_COLLATION FROM information_schema.TABLES WHERE TABLE_SCHEMA = '$dbname' AND TABLE_NAME = '$tb_name';";
		$ret=do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
		$tb_collation="";
		if ($ret->RecordCount()>0) {
			$row = $ret->fields;
			$tb_collation=$row->TABLE_COLLATION;
			if ($row->ENGINE=="MyISAM") {
				print "MyISAM detected, converting to InnoDB ";
				$sql="ALTER TABLE `$tb_name` ENGINE=InnoDB;";
				do_query($sql,$dbname);
				print " done.\n";
			}
			$ret->Close();
		}
		if ($tb_collation=="utf8_general_ci") continue;
		$sql="ALTER TABLE `$tb_name` CONVERT TO CHARACTER SET utf8 COLLATE utf8_general_ci;";
		print "$sql ";
		mysql_select_db($dbname);
		mysql_query($sql);
		if (mysql_errno()!=0) {
			log_table_problems($dbname, $tb_name,mysql_errno(),mysql_error());
		}
		print " done\n";
	}
}

print "\nConverting special cases\n";
/* Treat special cases */
mysql_select_db("opmon4");
$sql="ALTER TABLE host_external_command drop primary key;";
print "$sql\n";
mysql_query($sql);
$sql="ALTER TABLE host_external_command CONVERT TO CHARACTER SET utf8 COLLATE utf8_general_ci;";
print "$sql\n";
mysql_query($sql);
$sql="ALTER TABLE host_external_command add primary key (`entry_time`,`host_id`,command_type(128),`contact_id`);";
print "$sql\n";
mysql_query($sql);
$sql="ALTER TABLE hostgroup_external_command drop primary key;";
print "$sql\n";
mysql_query($sql);
$sql="ALTER TABLE hostgroup_external_command CONVERT TO CHARACTER SET utf8 COLLATE utf8_general_ci;";
print "$sql\n";
mysql_query($sql);
$sql="ALTER TABLE hostgroup_external_command add primary key (`entry_time`,`hostgroup_id`,command_type(128),`contact_id`);";
print "$sql\n";
mysql_query($sql);
$sql="ALTER TABLE service_external_command drop primary key;";
print "$sql\n";
mysql_query($sql);
$sql="ALTER TABLE service_external_command CONVERT TO CHARACTER SET utf8 COLLATE utf8_general_ci;";
print "$sql\n";
mysql_query($sql);
$sql="ALTER TABLE service_external_command add primary key (`entry_time`,`host_id`,`service_id`,command_type(128),`contact_id`);";
print "$sql\n";
mysql_query($sql);
$sql="ALTER TABLE servicegroup_external_command drop primary key;";
print "$sql\n";
mysql_query($sql);
$sql="ALTER TABLE servicegroup_external_command CONVERT TO CHARACTER SET utf8 COLLATE utf8_general_ci;";
print "$sql\n";
mysql_query($sql);
$sql="ALTER TABLE servicegroup_external_command add PRIMARY KEY  (`entry_time`,`servicegroup_id`,command_type(128),`contact_id`);";
print "$sql\n";
mysql_query($sql);

print "\nConverting fields\n";

convert_tables_to_utf($tables);

print "\nDatabase convertion done\n";

exit(0);

function get_tables($dbname)
{
	mysql_select_db($dbname);
	$sql = "show tables;";
	$tb_array=array();
	$ret = mysql_query($sql);
	while ($row = mysql_fetch_row($ret)) {
		$tb_array[]=$row[0];
	}
	mysql_free_result($ret);
	return($tb_array);
}

function get_databases()
{
	$sql = "show databases;";
	$db_array=array();
	$ret = do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
	while(!$ret->EOF) {
		$row = $ret->fields;
		$db_array[]=$row->Database;
		$ret->MoveNext();
	}
	$ret->Close();
	return($db_array);
}

function convert_tables_to_utf($tables)
{	
	foreach($tables as $db => $a_tables) {
	
		foreach($a_tables as $tb) {
		
			print "Working on table $tb:\n";
	
			$q = "desc $tb";
			$ret = do_query($q,$db,OPDB_FETCH_OBJ);
			$update_fields = array();
			$compare_fields = array();
			while(!$ret->EOF) {
	
				if (strstr($ret->fields->Type,"varchar") !== false || 
				    strstr($ret->fields->Type,"text") !== false) {
	
					$update_fields[] = $ret->fields->Field;
	
				} else {
					$compare_fields[] = $ret->fields->Field;
				}
	
				$ret->MoveNext();
			}
			$ret->Close();
	
			if (!empty($update_fields)) {
	
				print "\tWe need to convert these table fields:\n";
				foreach($update_fields as $f) {
					print "\t\t$f\n";
				}
				print "\tConverting:     ";
	
				$q = "select * ".
				     "from $tb";
	
				$ret = do_query($q,$db,OPDB_FETCH_OBJ);
				$c = 0;
				$problems = 0;
				while(!$ret->EOF) {
	
					give_feedback($c);
	
					$bypass = true;
					foreach($update_fields as $f) {
	
						$aux = json_encode($ret->fields->$f);
						$ret->fields->$f = addslashes(utf8_encode($ret->fields->$f));
						if ($aux == false || $aux == "null")
							$bypass = false;
					}

					if (!$bypass) {
	
						$problems++;
	
						$aux = array();
						foreach($update_fields as $f) {
							$aux[] = "$f = '{$ret->fields->$f}' ";
						}
	
						$q = "update $tb ".
						     "set ".implode(",",$aux)." ".
						     "where ";

						$aux = array();
						foreach($compare_fields as $f) {
							if ($ret->fields->$f == null) {
								$aux[] = "isnull($f)";
							} else {
								$aux[] = "$f = '".addslashes($ret->fields->$f)."'";
							}
						}

						$q .= implode(" and ",$aux);

						// RUN  UPDATE QUERY!
						$ret2 = do_query($q,$db,OPDB_FETCH_OBJ);
						$ret2->Close();
	
					}
	
	
					$c++;
					if ($c > 3) {
						$c = 0;
					}
	
					$ret->MoveNext();
				}
				$ret->Close();
	
				print "\n\t$problems rows updated\n";
	
			} else {
				print "\tdoesn't need convertion\n";
			}
	
	
			print "\n";
		}
	
	}
}

function give_feedback($count) {

	print chr(8).chr(8).chr(8);
	switch($count) {

	case 0:
		print "[|]";
		break;

	case 1:
		print "[/]";
		break;

	case 2:
		print "[-]";
		break;

	case 3:
		print "[\\]";
		break;
	}
}

function log_table_problems($dbname, $tb_name,$errno,$err_string)
{
	$handle = fopen("tables-problems.log", "a+");
	$logMsg=$dbname." - ".$tb_name." - ".$errno." - ".$err_string."\n";
	fputs($handle, $logMsg);
	fclose($handle);
}

?>

